unit _chan_pr;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  Tchan_prop = class(TForm)
    Label1: TLabel;
    Topic: TEdit;
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    ListBox1: TListBox;
    Limit: TEdit;
    Key: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure BanClick(Sender: TObject);
    procedure LimitKeyPress(Sender: TObject; var Key: Char);
  private
  public
    procedure ShowProp(Name: String);
  end;

var
  chan_prop: Tchan_prop;
  Flg: array[1..2] of array[1..8] of boolean;
implementation
uses datast, main, types, mytime;
{$R *.DFM}
var ChName: String;
    OldTopic, OldKey, OldLimit: String;
function CharToPos(C: Char): Byte;
begin
 Result := 0;
 case C of
  'i' : Result := 1;
  'l' : Result := 2;
  'p' : Result := 3;
  's' : Result := 4;
  'k' : Result := 5;
  'm' : Result := 6;
  'n' : Result := 7;
  't' : Result := 8;
 end;
end;
function PosToChar(P: Byte): Char;
begin
  Result := #0;
  case P of
   1 : Result := 'i';
   2 : Result := 'l';
   3 : Result := 'p';
   4 : Result := 's';
   5 : Result := 'k';
   6 : Result := 'm';
   7 : Result := 'n';
   8 : Result := 't';
  end;
end;
procedure TChan_Prop.ShowProp(Name: String);
var ChInfo: TChannelInfo;
    i: integer;
    Comp: TComponent;
    Blist: TStringList;
begin
  ChName := Name;
  Caption := 'Properties of channel '+Name;
  ChInfo := DataStore.GetChannelInfo(Name);
  BList := DataStore.GetBanList(Name);
  ListBox1.Items.Text := Blist.Text;
  Blist.Free;
  Topic.Text := ChInfo.TOPIC;
  OldTopic := ChInfo.TOPIC;
  for i := 1 to 8 do
  begin
    Comp := FindComponent('CheckBox'+IntToStr(i));
    if Pos(PosToChar(i), ChInfo.FLAGS) > 0 then
    begin
      Flg[1][i] := True;
      Flg[2][i] := True;
      If Assigned(Comp) and (Comp is TCheckBox) then
       (Comp as TCheckBox).Checked := True;
    end else
    begin
      Flg[1][i] := False;
      Flg[2][i] := False;
      If Assigned(Comp) and (Comp is TCheckBox) then
       (Comp as TCheckBox).Checked := False;
    end;
  end;
  if Flg[1][2] then Limit.Text := IntToStr(ChInfo.LIMIT) else Limit.Text := '';
  if Flg[1][5] then Key.Text   := ChInfo.KEY else Key.Text := '';
  OldKey := Key.Text;
  OldLimit := Limit.Text;
  ShowModal;
end;
procedure Tchan_prop.Button1Click(Sender: TObject);
var i: integer;
    Comp: TComponent;
    Mess_p, Mess_m: String;
    ChInfo: TChannelInfo;
begin
  Mess_p := ''; Mess_m := '';
  ChInfo := DataStore.GetChannelInfo(ChName);
  ChInfo.Flags := '';
  for i := 1 to 8 do
  begin
    Comp := FindComponent('CheckBox'+IntToStr(i));
     If Assigned(Comp) and (Comp is TCheckBox) then
     Flg[2][i] := (Comp as TCheckBox).Checked;
     if (Flg[2][i] <> Flg[1][i]) then
       if Flg[2][i] then Mess_p := Mess_p + PosToChar(i)
                    else Mess_m := Mess_m + PosToChar(i);
     if Flg[2][i] then ChInfo.Flags := ChInfo.Flags + PosToChar(i);
  end;
  if OldTopic <> Topic.Text then
  begin
    ChInfo.TOPIC := Topic.Text;
    ChInfo.TTIME := GetIrcTime;
    MainForm.WriteAll(Format(':%s!%s@%s TOPIC #%s :%s', ['OperServ', ServerName, Mainform.pircds.Socket.LocalHost, ChName, Topic.Text]));
  end;
  if Flg[2][2] then
  begin
    ChInfo.LIMIT := StrToInt(Limit.Text);
    if Flg[1][2] and (OldLimit <> Limit.Text) then mess_p := mess_p+'l';
  end;
  if Flg[2][5] then 
  begin
    ChInfo.Key := Key.Text;
    if Flg[1][5] and (OldKey <> Key.Text) then mess_p := mess_p + 'k';
  end;
  If (Mess_p <> '') or (Mess_m <> '') then
  begin
    If Mess_p <> '' then Mess_p := '+'+SortChars(Mess_p);
    If Mess_m <> '' then Mess_p := Mess_p + '-'+SortChars(Mess_m);
    If Flg[2][5] then Mess_p := Mess_p +' '+ ChInfo.Key;
    If Flg[2][2] then Mess_p := Mess_p +' '+ itoa(ChInfo.Limit);
    MainForm.WriteChan(0, ChName, Format(':%s MODE %s %s', ['OperServ!'+ServerName+'@'+MainForm.pircds.Socket.LocalHost, '#'+ChName, Mess_p]));
  end;
  DataStore.SetChannelInfo(ChName, ChInfo);
  MainForm.WriteFlag(Format(':%s NOTICE %s :*** Global -- from %s %s used SAMODE (%s)', [ServerName, 'OperServ', ServerName, 'OperServ', '#'+ChName+' '+Mess_p]), 's');
end;

procedure Tchan_prop.LimitKeyPress(Sender: TObject; var Key: Char);
begin
  if not (Key in [#8, '0'..'9']) then Key := #0;
end;
procedure Tchan_prop.BanClick(Sender: TObject); // unban
var Who: String;
    I: Integer;
begin
  I := 0;
  while (i <= ListBox1.Items.Count - 1) do
    if ListBox1.Selected[i] then
    begin
      Who := ListBox1.Items.Strings[i];
      if pos(' ', Who) > 0 then Delete(Who, Pos(' ', Who), Length(Who) - Pos(' ', Who) + 1);
      if DataStore.DelBan(ChName, Who) then
      begin
         MainForm.WriteChan(0, ChName, Format(':%s MODE %s %s %s', ['OperServ!'+ServerName+'@'+ServerName, '#'+ChName, '-b', Who]));
         ListBox1.Items.Delete(i);
      end else inc(i);
    end else inc(i);
end;
end.
