unit datast;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, MDBFTable, Loger, Types, MyTime, DBTables;
type
  TDataStore = class(TDataModule)
    Servers: TMDBFTable;
    Channels: TMDBFTable;
    ChanUsers: TMDBFTable;
    Opers: TMDBFTable;
    Invites: TMDBFTable;
    Bans: TMDBFTable;
    ServersTYPE: TStringField;
    ServersNAME: TStringField;
    ServersPASSWORD: TStringField;
    ServersADDR: TStringField;
    ServersCLASS: TStringField;
    ServersPORT: TStringField;
    ChannelsID: TStringField;
    ChannelsNAME: TStringField;
    ChannelsFLAGS: TStringField;
    ChannelsTOPIC: TStringField;
    ChannelsCTIME: TStringField;
    ChannelsTTIME: TStringField;
    ChannelsKEY: TStringField;
    ChannelsLIMIT: TStringField;
    ChanUsersCHANNEL: TStringField;
    ChanUsersNICK: TStringField;
    ChanUsersOPER: TStringField;
    ChanUsersVOICE: TStringField;
    ChanUsersEXTMODE: TStringField;
    OpersNICK: TStringField;
    OpersHOSTMASK: TStringField;
    OpersPASSWORD: TStringField;
    OpersMODE: TStringField;
    InvitesCHANNEL: TStringField;
    InvitesNICK: TStringField;
    BansCHANNEL: TStringField;
    BansUSERHOST: TStringField;
    BansBANMAKER: TStringField;
    BansTIME: TStringField;
    Users: TMDBFTable;
    UsersID: TStringField;
    UsersNICK: TStringField;
    UsersUSERID: TStringField;
    UsersHOSTNAME: TStringField;
    UsersREALNAME: TStringField;
    UsersINVISIBLE: TStringField;
    UsersOPER: TStringField;
    UsersWALLOP: TStringField;
    UsersSERVICE: TStringField;
    UsersSOCKET: TStringField;
    UsersLOGIN: TStringField;
    UsersEXTMODE: TStringField;
    UsersTIME: TStringField;
    UsersAWAY: TStringField;
    RegUsers: TMDBFTable;
    Reg_Users: TMDBFTable;
    RegUsersID: TStringField;
    RegUsersNICK: TStringField;
    RegUsersUSERID: TStringField;
    RegUsersHOSTNAME: TStringField;
    RegUsersKILL: TStringField;
    RegUsersMFORWARD: TStringField;
    RegUsersMLOCK: TStringField;
    RegUsersMRECEIPTS: TStringField;
    RegUsersNOMEMO: TStringField;
    RegUsersNOOP: TStringField;
    RegUsersSECURE: TStringField;
    RegUsersSHOWEMAIL: TStringField;
    RegUsersURL: TStringField;
    RegUsersPASSWD: TStringField;
    RegUsersEMAIL: TStringField;
    RegUsersFORWARD: TStringField;
    RegUsersREALNAME: TStringField;
    Reg_UsersID: TStringField;
    Reg_UsersNICK: TStringField;
    Reg_UsersSTATUS: TStringField;
    Reg_UsersTIMEOUT: TStringField;
    Reg_UsersKILL: TStringField;
    procedure DataStoreCreate(Sender: TObject);
    procedure DataStoreDestroy(Sender: TObject);
  private
    { Private declarations }
  public
// User managing functions
    function NickBySocket(Socket: Integer): String;
    function SocketByNick(Nick: String): Integer;
    function UserBySocket(Socket: Integer): String;
    function FindNewUserId: Cardinal;
    function FindUserId(Nick: String): Cardinal; overload;
    function FindUserId(Socket: Integer): Cardinal; overload;
    function AddUser(Nick: String; Socket: Cardinal): boolean;
    procedure DelUser(Nick: String); overload;
    procedure DelUser(Socket: Integer); overload;
    procedure SetUserInfo(Nick: String; info: TUserInfo); overload;
    procedure SetUserInfo(Socket: Integer; info: TUserInfo); overload;
    function GetUserInfo(Nick: String): TUserInfo; overload;
    function GetUserInfo(Socket: Integer): TUserInfo; overload;
    function IsOn(Nick: String): boolean; overload;
    function UserCount(var Invis, Ops, Login: Integer): Integer;
    procedure UpdateTime(Socket: Integer);
    function GetTime(Socket: Integer): DWORD;
    function GetUsers(Oper: boolean): TStringList;
// Channel managing functions
    function FindNewChannelId: Cardinal;
    function FindChannelId(Ch: String): Cardinal;
    function GetChannelName(I: Integer): String;
    function AddChannel(Ch: String): boolean;
    procedure DelChannel(Ch: String); overload;
    procedure DelChannel(I: Integer); overload;
    procedure SetChannelInfo(Ch: String; info: TChannelInfo);
    function GetChannelInfo(Ch: String): TChannelInfo;
    function GetList(Nick, List: String): TStringList;
    function GetChansCount: Integer;
    function SetTopic(Ch, Nick, Topic: String): byte;
    {0 - Ok
     1 - User is not on channel
     2 - Oper priveledge needs
     3 - No suck channel}
// User on channel managing functions
    function IsBan(Nick: String; Ch: String): boolean;
    function IsInvite(Nick: String; Ch: String): boolean;
    function IsOn(Nick: String; Ch: String): boolean; overload;
    function AddToChan(Nick, Ch, Key: String): byte; overload;
    function AddToChan(Socket: Integer; Ch, Key: String): byte; overload;
    {Result = 0 - No such ch
     Result = 1 - Ok
     Result = 2 - User is ban
     Result = 3 - User should be invited at first
     Result = 4 - User already on the channel
     Result = 5 - Key invalid}
    function DelFromChan(Nick, Ch: String): boolean; overload;
    function DelFromChan(Nick: String; I: integer): boolean; overload;
    function GetNames(Nick, List: String): TStringList; overload;
    function GetNames(I: Integer; Nick: String): String; overload;
    function GetUserCount(Ch: String): Cardinal; overload;
    function GetUserCount(I: Integer): Cardinal; overload;
    function MakeOper(Ch: String; Nick: String; flag: boolean): byte;
    function MakeVoice(Ch: String; Nick: String; flag: boolean): byte;
    function CanSendChan(Socket: Integer; Chan: String): byte;
    {0 - Ok
     1 - No chan
     2 - +m
     3 - +n}
    function GetUsersSockets(Ch: String): TStringList;
    function GetBanList(Ch: String): TStringList;
    function AddToBan(Ch, Mask, Nick: String; Time: DWORD): boolean;
    function DelBan(Ch, Mask: String): boolean;
    procedure AddToInvite(I: Integer; Nick: String);
    function GetUChans(Nick: String): String;
//Oper functions
    function GetOper(Nick: String): TOperInfo;
    procedure SetOper(Nick: String; OInfo: TOperInfo);
    procedure AddOper(OInfo: TOperInfo);
    procedure DelOper(Nick: String);
    function BecomeOper(Nick, UserId, Host, Name, Pass: String; var Flags: String): byte;
//Special functions
    function Motd: TStringList;
    function Info: TStringList;
    function GetWhoList(Nick, Who: String; O: boolean): TStringList;
    function GetUsersFlag(Flag: char): TStringList;
// NickServ specific functions
    function GetRegistredUserInfo(Nick: String): TRegUserInfo;
    procedure SetRegistredUserInfo(Nick: String; Info: TRegUserInfo);
    function GetGhostInfo(Nick: String): TGhostInfo;
    procedure SetGhostInfo(Nick: String; Info: TGhostInfo);
    function IsKillGhost: boolean;
  end;

var
  DataStore: TDataStore;
Const ServerName = 'pirat';

implementation
{$R *.DFM}
var DataDir: String;
procedure TDataStore.DataStoreCreate(Sender: TObject);
begin
 Servers.FileName := DataDir + 'server.dbf';
 Channels.FileName := DataDir + 'channel.dbf';
 ChanUsers.FileName := DataDir + 'chusers.dbf';
 Opers.FileName := DataDir + 'oper.dbf';
 Invites.FileName := DataDir + 'invite.dbf';
 Bans.FileName := DataDir + 'chban.dbf';
 Users.FileName := DataDir + 'user.dbf';
 RegUsers.FileName := DataDir + 'RegUser.dbf';
 Reg_Users.FileName := DataDir + 'RegUser_.dbf';
 try
   Servers.Open;
   Channels.Open;
   ChanUsers.Open;
   Opers.Open;
   Invites.Open;
   Bans.Open;
   Users.Open;
   RegUsers.Open;
   Reg_Users.Open;
  except on E: Exception do
  begin
    LogAppend('Exception during open system tables.');
    Application.Terminate;
  end;
 end;
 LogAppend('System tables prepared for use');
end;
procedure TDataStore.DataStoreDestroy(Sender: TObject);
begin
   Channels.Zap;
   ChanUSers.Zap;
   Invites.Zap;
   Bans.Zap;
   Users.Zap;
   Reg_Users.Zap;
   try
     Opers.Close;
     RegUsers.Close;
   except
   end;
end;
function TDataStore.FindNewUserId: Cardinal;
var I: Cardinal;
begin
  Users.First;
  Result := atoi(UsersId.AsString);
  If Result <> 1 then
  begin
    Result := 1;
    Exit;
  end;
  Users.Next;
  while not Users.Eof do
  begin
    I := UsersId.AsInteger;
    if abs(Result - I) <> 1 then break;
    Result := I;
    Users.Next;
  end;
  Inc(Result);
end;
function TDataStore.FindUserId(Nick: String): Cardinal;
begin
 Users.First;
 Result := 0;
 while not Users.Eof do
 begin
   If LowerCase(UsersNick.AsString) = LowerCase(Nick) then
   begin
     Result := UsersId.AsInteger;
     Exit;
   end;
   Users.Next;
 end;
end;
function TDataStore.FindUserId(Socket: Integer): Cardinal;
begin
 Users.First;
 Result := 0;
 while not Users.Eof do
 begin
   If UsersSocket.AsInteger = Socket then
   begin
     Result := UsersId.AsInteger;
     Exit;
   end;
   Users.Next;
 end;
end;
function TDataStore.AddUser(Nick: String; Socket: Cardinal): boolean;
var Id: Cardinal;
begin
  Result := (FindUserId(Nick) = 0);
  If not Result then Exit;
  Id := FindNewUserId;
  if not Users.Eof then
    Users.InsertRecord([Id, Nick, '', '', '', false, false, false, 0, false, Socket, '', GetIrcTime, ''])
  else
    Users.AppendRecord([Id, Nick, '', '', '', false, false, false, 0, false, Socket, '', GetIrcTime, ''])
end;
procedure TDataStore.DelUser(Nick: String);
var I: Cardinal;
    IsAny: array [0..100] of byte;
begin
  I := FindUserId(Nick);
  Nick := LowerCase(Nick);
  If I <> 0 then
  begin
    For I := 1 to 100 do IsAny[I] := 0;
    Users.Delete;
    ChanUsers.First;
    while not ChanUsers.Eof do
     If LowerCase(ChanUsersNick.AsString) = Nick then
        begin
          If IsAny[atoi(ChanUsersChannel.AsString)] = 0 then IsAny[atoi(ChanUsersChannel.AsString)] := 1;
          ChanUsers.Delete;
        end
       else begin
         IsAny[atoi(ChanUsersChannel.AsString)] := 2;
         ChanUsers.Next;
       end;
    For I := 1 to 100 do If (IsAny[I] = 1) then DelChannel(I);
  end;
end;
procedure TDataStore.DelUser(Socket: Integer);
var I: Cardinal;
    Nick : String;
    IsAny: array [0..100] of byte;
begin
  I := FindUserId(Socket);
  If I <> 0 then
  begin
    Nick := LowerCase(UsersNick.AsString);
    Users.Delete;
    For I := 1 to 100 do IsAny[I] := 0;
    ChanUsers.First;
    while not ChanUsers.Eof do
     If LowerCase(ChanUsersNick.AsString) = Nick then
        begin
          If IsAny[atoi(ChanUsersChannel.AsString)] = 0 then IsAny[atoi(ChanUsersChannel.AsString)] := 1;
          ChanUsers.Delete;
        end
       else begin
         IsAny[atoi(ChanUsersChannel.AsString)] := 2;
         ChanUsers.Next;
       end;
    For I := 1 to 100 do If (IsAny[I] = 1) then DelChannel(I);
  end;
end;
procedure TDataStore.SetUserInfo(Nick: String; info: TUserInfo);
var I: Cardinal;
begin
  I := FindUserId(Nick);
  if I <> 0 then
  begin
    Users.Edit;
    Users.SetFields([info.ID, info.NICK, info.USERID, info.HOSTNAME,
                     info.REALNAME, info.INVISIBLE, info.OPER,
                     info.WALLOP, info.LOGIN, info.SERVICE, info.Socket,
                     info.EXTMODE, info.TIME, info.Away]);
    Users.Post;                 
 end;                    
end;
procedure TDataStore.SetUserInfo(Socket: Integer; info: TUserInfo);
var I: Cardinal;
begin
  I := FindUserId(Socket);
  if I <> 0 then
  begin
    Users.Edit;
    Users.SetFields([info.ID, info.NICK, info.USERID, info.HOSTNAME,
                     info.REALNAME, info.INVISIBLE, info.OPER,
                     info.WALLOP, info.LOGIN, info.SERVICE, info.Socket,
                     info.EXTMODE, info.TIME, info.Away]);
    Users.Post;
  end;                   
end;
function TDataStore.GetUserInfo(Nick: String): TUserInfo;
var I: Cardinal;
begin
  I := FindUserId(Nick);
  If I <> 0 then
  begin
    Result.ID        := atoi(UsersId.AsString);
    Result.NICK      := UsersNick.AsString;
    Result.USERID    := UsersUserid.AsString;
    Result.HOSTNAME  := UsersHostname.AsString;
    Result.REALNAME  := UsersRealName.AsString;
    Result.INVISIBLE := UsersInvisible.AsBoolean;
    Result.OPER      := UsersOper.AsBoolean;
    Result.WALLOP    := UsersWallop.AsBoolean;
    Result.LOGIN     := UsersLogin.AsInteger;
    Result.SERVICE   := UsersService.AsBoolean;
    Result.SOCKET    := UsersSocket.AsInteger;
    Result.EXTMODE   := UsersExtmode.AsString;
    Result.Time      := atoi(UsersTime.AsString);
    Result.Away      := UsersAway.AsString;
  end else Result.ID := 0;
end;
function TDataStore.GetUserInfo(Socket: Integer): TUserInfo;
var I: Cardinal;
begin
  I := FindUserId(Socket);
  If I <> 0 then
  begin
    Result.ID        := UsersId.AsInteger;
    Result.NICK      := UsersNick.AsString;
    Result.USERID    := UsersUserid.AsString;
    Result.HOSTNAME  := UsersHostname.AsString;
    Result.REALNAME  := UsersRealName.AsString;
    Result.INVISIBLE := UsersInvisible.AsBoolean;
    Result.OPER      := UsersOper.AsBoolean;
    Result.WALLOP    := UsersWallop.AsBoolean;
    Result.LOGIN     := UsersLogin.AsInteger;
    Result.SERVICE   := UsersService.AsBoolean;
    Result.SOCKET   := UsersSocket.AsInteger;
    Result.EXTMODE   := UsersExtmode.AsString;
    Result.Time      := atoi(UsersTime.AsString);
    Result.Away      := UsersAway.AsString;
  end else Result.ID := 0;
end;
function TDataStore.FindNewChannelId: Cardinal;
var I: Cardinal;
begin
  Channels.First;
  Result := atoi(ChannelsId.AsString);
  If Result <> 1 then
  begin
    Result := 1;
    Exit;
  end;
  Channels.Next;
  while not Channels.Eof do
  begin
    I := ChannelsId.AsInteger;
    if abs(Result - I) <> 1 then break;
    Result := I;
    Channels.Next;
  end;
  Inc(Result);
end;
function TDataStore.FindChannelId(Ch: String): Cardinal;
begin
 Channels.First;
 Result := 0;
 while not Channels.Eof do
 begin
   If LowerCase(ChannelsName.AsString) = LowerCase(Ch) then
   begin
     Result := ChannelsId.AsInteger;
     Exit;
   end;
   Channels.Next;
 end;
end;
function TDataStore.AddChannel(Ch: String): boolean;
var Id: Cardinal;
begin
  Result := (FindChannelId(Ch) = 0);
  If not Result then Exit;
  Id := FindNewChannelId;
  If not Channels.Eof then
    Channels.InsertRecord([Id, Ch, '', '', 0, 0, '', 0])
  else
    Channels.AppendRecord([Id, Ch, '', '', 0, 0, '', 0]);
end;
procedure TDataStore.DelChannel(I: Integer);
begin
  If I <> 0 then
  begin
    If atoi(ChannelsId.AsString) = I then Channels.Delete else
    begin
      Channels.First;
      while (not Channels.Eof) do
       if (atoi(ChannelsId.AsString) <> I) then Channels.Next
       else Channels.Delete;
    end;
    ChanUsers.First;
    while not ChanUsers.Eof do
     If atoi(ChanUsersChannel.AsString) = I then
       ChanUsers.Delete else ChanUsers.Next;
    Bans.First;
    while not Bans.Eof do
     If atoi(BansChannel.AsString) = I then
       Bans.Delete else Bans.Next;
    Invites.First;   
    while not Invites.Eof do
      If atoi(InvitesChannel.AsString) = I then
        Invites.Delete else Invites.Next;      
  end;
end;
procedure TDataStore.DelChannel(Ch: String);
var I: Integer;
begin
  I := FindChannelId(Ch);
  DelChannel(I);
end;
procedure TDataStore.SetChannelInfo(Ch: String; info: TChannelInfo);
var I: Cardinal;
begin
  I := FindChannelId(Ch);
  if I <> 0 then
  begin
    Channels.Edit;
    Channels.SetFields([info.ID, info.NAME, info.FLAGS, info.TOPIC, info.CTIME, info.TTIME, info.KEY, info.LIMIT]);
    Channels.Post;
  end;
end;
function TDataStore.GetChannelInfo(Ch: String): TChannelInfo;
var I: Cardinal;
begin
  I := FindChannelId(Ch);
  If I <> 0 then
  begin
    Result.ID    := ChannelsId.AsInteger;
    Result.NAME  := ChannelsName.AsString;
    Result.FLAGS := ChannelsFlags.AsString;
    Result.TOPIC := ChannelsTopic.AsString;
    Result.CTIME := ChannelsCTime.AsInteger;
    Result.TTIME := ChannelsTTime.AsInteger;
    Result.KEY   := ChannelsKey.AsString;
    Result.LIMIT := ChannelsLimit.AsInteger;
  end else Result.Id := 0;
end;
function TDataStore.IsBan(Nick: String; Ch: String): boolean;
var I, J: Integer;
    info: TUserInfo;
    N, H: boolean;
    HNick, Host: String;
begin
 Result := false;
 I := FindChannelId(Ch);
 info := GetUserInfo(Nick);
 if I <> 0 then
 begin
   Bans.First;
   while not Bans.Eof do
   begin
    if (BansChannel.AsInteger = I) then
    begin
      N := false;
      J := Pos('@', BansUserHost.AsString);
      Host := '';
      If J > 0 then
      begin
        HNick := Copy(BansUserHost.AsString, 1, J-1);
        Host := BansUserHost.AsString;
        Delete(Host, 1, Length(HNick)+1);
      end else HNick := BansUserHost.AsString;
      HNick := Chop(HNick);
      Host := Chop(Host);
      If (LowerCase(Nick)+'!'+info.USERID = LowerCase(HNick)) or (HNick = '*')
      or (HNick = '*!*') then N := true;
      H := EqualHosts(info.HOSTNAME, Host);
      Result := H and N;
    end;
   Bans.Next;
  end; 
 end;
end;
function TDataStore.IsInvite(Nick: String; Ch: String): boolean;
var I: Integer;
begin
 Result := false;
 I := FindChannelId(Ch);
 If I <> 0 then
   Invites.First;
   while (not Invites.Eof) and (not Result) do
   begin
     If (InvitesChannel.AsInteger = I) and (LowerCase(Nick) = LowerCase(InvitesNick.AsString)) then
       Result := true;
     Invites.Next;
   end;
end;
function TDataStore.AddToChan(Nick: String; Ch, Key: String): byte;
var I: Integer;
begin
  Result := 0;
  If IsBan(Nick, Ch) then
  begin
    Result := 2;
    Exit;
  end;
  I := FindChannelId(Ch);
  If I <> 0 then
  begin
    If (CharInString('i', ChannelsFlags.AsString) > 0) and
       (not IsInvite(Nick, Ch)) then
    begin
      Result := 3;
      Exit;
    end;
    If (CharInString('k', ChannelsFlags.AsString) > 0) and (ChannelsKey.AsString <> '') and (ChannelsKey.AsString <> Key) then
    begin
      Result := 5;
      Exit;
    end;
    If IsOn(Nick, Ch) then
    begin
      Result := 4;
      Exit;
    end;
    ChanUsers.AppendRecord([I, Nick, false, false, '']);
    Result := 1;
  end;
end;
function TDataStore.AddToChan(Socket: Integer; Ch, Key: String): byte;
begin
  Result := AddToChan(NickBySocket(Socket), Ch, Key);
end;
function TDataStore.IsOn(Nick: String; Ch: String): boolean;
var I: Integer;
begin
 I := FindChannelId(Ch);
 Result := false;
 If I <> 0 then
 begin
   ChanUsers.First;
   while not ChanUsers.Eof do
   begin
     if (atoi(ChanUsersChannel.AsString) = I) and (LowerCase(Nick) = LowerCase(ChanUsersNick.AsString))
     then begin Result := true; Exit; end;
     ChanUsers.Next;
   end;
 end;
end;
function TDataStore.DelFromChan(Nick: String; Ch: String): boolean;
var I: Integer;
begin
  I := FindChannelId(Ch);
  Result := DelFromChan(Nick, I);
end;
function TDataStore.DelFromChan(Nick: String; I: Integer): boolean;
var IsAny: boolean;
begin
  Result := false;
  Nick := LowerCase(Nick);
  If I <> 0 then
    ChanUsers.First;
    IsAny := false;
    While not ChanUsers.Eof do
      If (atoi(ChanUsersChannel.AsString) = I) then
      begin
        If LowerCase(ChanUsersNick.AsString) = Nick then
        begin
          ChanUsers.Delete;
          Result := true;
        end else begin ChanUsers.Next; IsAny := true; end;
      end else ChanUsers.Next;
  If Not IsAny then DelChannel(I);
end;
function TDataStore.GetList(Nick, List: String): TStringList;
var Ch1, Ch2, Mode: String;
    RName, Name, Topic, Uc: String;
    IO: Boolean;
begin
  Channels.First;
  Result := TStringList.Create;
  Ch2 := '';
  If Length(List) > 0 then
  begin
    If Pos(',', List) > 0 then
    begin
      Ch1 := Copy(List, 1, Pos(',', List)-1);
      Ch2 := List;
      Delete(Ch2, 1, Length(Ch1)+1);
      Ch1 := Chop(Ch1);
      Ch2 := Chop(Ch2);
    end else Ch1 := List;
  end else Ch1 := '';
  Ch1 := LowerCase(Ch1); Ch2 := LowerCase(Ch2); 
  while not Channels.Eof do
  begin
      Mode := ChannelsFlags.AsString;
      Name := ChannelsName.AsString;
      RName := LowerCase(Name);
      Uc := IntToStr(GetUserCount(ChannelsId.AsInteger));
      Topic := ChannelsTopic.AsString;
      IO := IsOn(Nick, Name);
      If (CharInString('s', Mode) > 0) and (not IO) then
      begin
         Channels.Next;
         Continue;
      end;
      If (CharInString('p', Mode) > 0) and (not IO) then
      begin
        Name := 'Prv';
        Topic := '';
      end;
      If ((Ch1 = '') and (Ch2 = '')) or (EqualNames(Ch1, RName) and (Ch1 <> '')) or (EqualNames(Ch2, RName) and (Ch2 <> '')) then
        Result.Add('#'+Name+' '+UC+' :'+Topic);
      Channels.Next;  
  end;
end;
function TDataStore.GetUserCount(Ch: String): Cardinal;
var I: Integer;
begin
  I := FindChannelId(Ch);
   Result := GetUserCount(I);
end;
function TDataStore.GetUserCount(I: Integer): Cardinal;
begin
  Result := 0;
  ChanUsers.First;
  while not ChanUsers.Eof do
  begin
   If (ChanUsersChannel.AsInteger = I) then Inc(Result);
   ChanUsers.Next;
  end;
end;
function TDataStore.GetNames(Nick, List: String): TStringList;
var Ch1, Ch2: String;
    Mode, Name: String;
begin
  Channels.First;
  Result := TStringList.Create;
  Ch2 := '';
  If Length(List) > 0 then
  begin
    If Pos(',', List) > 0 then
    begin
      Ch1 := Copy(List, 1, Pos(',', List)-1);
      Ch2 := List;
      Delete(Ch2, 1, Length(Ch1)+1);
      Ch1 := Chop(Ch1);
      Ch2 := Chop(Ch2);
    end else Ch1 := List;
  end else Ch1 := '';
  Ch1 := LowerCase(Ch1); Ch2 := LowerCase(Ch2);
  Channels.First;
  while not Channels.Eof do
  begin
    Mode := ChannelsFlags.AsString;
    Name := ChannelsName.AsString;
    If ((CharInString('s', Mode) > 0) or (CharInString('p', Mode) > 0)) and (not IsOn(Nick, Name)) then
    begin
      Channels.Next;
      Continue;
    end;
    If ((Ch1 = '') and (Ch2 = '')) or (Ch1 = LowerCase(Name)) or (Ch2 = LowerCase(Name)) then
      Result.Values[Name] := GetNames(ChannelsId.AsInteger, Nick);
    Channels.Next;
  end;
end;
function TDataStore.GetNames(I: Integer; Nick: String): String;
var IList: TStringList;
function NickIn(Nick: String): boolean;
var I: integer;
begin
  Result := false;
  Nick := LowerCase(Nick);
  for I := 0 to IList.Count - 1 do
   If Nick = LowerCase(IList.Strings[I]) then begin Result := true; exit; end;
end;
begin
 Users.First;
 IList := TStringList.Create;
 while not Users.Eof do
 begin
   If UsersInvisible.AsBoolean then IList.Add(UsersNick.AsString);
   Users.Next;
 end;
 ChanUsers.First;
 Result := '';
 while not ChanUsers.Eof do
 begin
  If (atoi(ChanUsersChannel.AsString) = I) and ((not NickIn(ChanUsersNick.AsString)) or (LowerCase(Nick) = LowerCase(ChanUsersNick.AsString))) then
  begin
    If Result <> '' then Result := Result + ' ';
    If ChanUsersOper.AsBoolean then Result := Result + '@'
       else If ChanUsersVoice.AsBoolean then Result := Result + '+';
    Result := Result + ChanUsersNick.AsString;
  end;
  ChanUsers.Next;
 end; 
 IList.Free;
end;
function TDataStore.IsOn(Nick: String): boolean;
begin
  Result := false;
  Users.First;
  Nick := LowerCase(Nick);
  while not Users.Eof do
  begin
   If Nick = LowerCase(UsersNick.AsString) then
   begin
     Result := true;
     exit;
   end;
   Users.next;
  end;
end;
function TDataStore.NickBySocket(Socket: Integer): String;
begin
  Result := '';
  Users.First;
  while not Users.Eof do
    if UsersSocket.AsInteger = Socket then
    begin
      Result := UsersNick.AsString;
      Exit;
    end else Users.Next;
end;
function TDataStore.SocketByNick(Nick: String): Integer;
begin
  Result := 0;
  Users.First;
  Nick := LowerCase(Nick);
  while not Users.Eof do
    if LowerCase(UsersNick.AsString) = Nick then
    begin
      Result := UsersSocket.AsInteger;
      Exit;
    end else Users.Next;
end;
function TDataStore.UserBySocket(Socket: Integer): String;
begin
  Result := '';
  Users.First;
  while not Users.Eof do
    if UsersSocket.AsInteger = Socket then
    begin
      Result := UsersNick.AsString+'!'+UsersUserId.AsString+'@'+UsersHostname.AsString;
      Exit;
    end else Users.Next;
end;
function TDataStore.MakeOper(Ch: String; Nick: String; flag: boolean): byte;
var I: Integer;
begin
  Result := 0;
  Nick := LowerCase(Nick);
  I := FindChannelId(Ch);
  If I <> 0 then
  begin
    ChanUsers.First;
    while not ChanUsers.Eof do
      if (LowerCase(ChanUsersNick.AsString) = Nick) and
         (atoi(ChanUsersChannel.AsString) = I) then
      begin
        If ChanUsersOper.AsBoolean <> flag then
        begin
          ChanUsers.Edit;
          ChanUsersOper.AsBoolean := flag;
          ChanUsers.Post;
          Result := 1;
        end else Result := 2;
        Exit;
      end else ChanUsers.Next;
  end;
end;
function TDataStore.MakeVoice(Ch: String; Nick: String; flag: boolean): byte;
var I: Integer;
begin
  Result := 0;
  Nick := LowerCase(Nick);
  I := FindChannelId(Ch);
  If I <> 0 then
  begin
    ChanUsers.First;
    while not ChanUsers.Eof do
      if (LowerCase(ChanUsersNick.AsString) = Nick) and
         (atoi(ChanUsersChannel.AsString) = I) then
      begin
        If ChanUsersVoice.AsBoolean <> flag then
        begin
          ChanUsers.Edit;
          ChanUsersVoice.AsBoolean := flag;
          ChanUsers.Post;
          Result := 1;
        end else Result := 2;
        Exit;
      end else ChanUsers.Next;
  end;
end;
function TDataStore.SetTopic(Ch, Nick, Topic: String): Byte;
var I: Integer;
    ChInfo: TChannelInfo;
begin
  I := FindChannelId(Ch);
  If I <> 0 then
  begin
    If not IsOn(Nick, Ch) then
    begin
      Result := 1;
      Exit;
    end; 
    ChInfo := GetChannelInfo(Ch);
    If (CharInString('t', ChInfo.FLAGS) > 0) and (not ChanUsersOper.AsBoolean) then
    begin
      Result := 2;
      Exit;
    end;
    ChInfo.TOPIC := Topic;
    ChInfo.TTIME := GetIrcTime;
    SetChannelInfo(Ch, ChInfo);
    Result := 0;
  end else Result := 3;
end;
function TDataStore.Motd: TStringList;
begin
  Result := TStringList.Create;
  If FileExists(DataDir+'motd.dat') then Result.LoadFromFile(DataDir + 'motd.dat');
end;
function TDataStore.Info: TStringList;
begin
  Result := TStringList.Create;
  If FileExists(DataDir+'info.dat') then Result.LoadFromFile(DataDir + 'info.dat');
end;
function TDataStore.CanSendChan(Socket: Integer; Chan: String): byte;
var I: Integer;
    ChInfo: TChannelInfo;
begin
  ChInfo := GetChannelInfo(Chan);
  I := ChInfo.ID;
  If (I > 0) then
  begin
    If not IsOn(NickBySocket(Socket), Chan) and (CharInString('n', ChInfo.FLAGS) > 0) then
    begin
      Result := 2;
      Exit;
    end;
    If (CharInString('m', ChInfo.FLAGS) > 0) and not (ChanUsersOper.AsBoolean or ChanUsersVoice.AsBoolean) then
    begin
      Result := 2;
      Exit;
    end;
    Result := 0;
  end else Result := 1;
end;
function TDataStore.GetUsersSockets(Ch: String): TStringList;
var I: Integer;
    NList: TStringList;
begin
  Result := TStringList.Create;
  I := FindChannelId(Ch);
  If I = 0 then Exit;
  NList := TStringList.Create;
  ChanUsers.First;
  while not ChanUsers.Eof do
  begin
    If (ChanUsersChannel.AsInteger) = I then
      NList.Add(LowerCase(ChanUsersNick.AsString));
    ChanUsers.Next;
  end;
  Users.First;
  while not Users.Eof do
  begin
    for i := 0 to NList.Count - 1 do
     if Nlist.Strings[i] = LowerCase(UsersNick.AsString) then
     begin
       Result.Add(UsersSocket.AsString);
       NList.Delete(i);
       break;
     end;
    Users.Next;
  end;
  NList.Free;
end;
function TDataStore.GetBanList(Ch: String): TStringList;
var I: Integer;
begin
  I := FindChannelId(Ch);
  Result := TStringList.Create;
  If I <> 0 then
  begin
    Bans.First;
    while not Bans.Eof do
    begin
      If atoi(BansChannel.AsString) = I then
        Result.Add(BansUSERHOST.AsString+' '+BansBANMAKER.AsString+' '+BansTIME.AsString);
      Bans.Next;
    end;
  end;
end;
function TDataStore.AddToBan(Ch, Mask, Nick: String; Time: DWord): boolean;
var I: Integer;
begin
  I := FindChannelId(Ch);
  Bans.First;
  while not Bans.Eof do
  begin
    If (I = atoi(BansChannel.AsString)) and (BansUserhost.AsString = Mask) then
    begin
      Result := false;
      Exit;
    end;
    Bans.Next;  
  end;
  Result := true;
  Bans.AppendRecord([I, Mask, Nick, Time]);
end;
function TDataStore.DelBan(Ch, Mask: String): boolean;
var I: Integer;
begin
  I := FindChannelId(Ch);
  Bans.First;
  while not Bans.Eof do
    If (I = atoi(BansChannel.AsString)) and (BansUserhost.AsString = Mask) then
    begin
      Result := true;
      Bans.Delete;
      Exit;
    end else Bans.Next;
  Result := false;  
end;
procedure TDataStore.AddToInvite(I: Integer; Nick: String);
begin
  Nick := LowerCase(Nick);
  Invites.First;
  while not Invites.Eof do
    If (atoi(InvitesChannel.AsString) = I) and (LowerCase(InvitesNick.AsString) = Nick)
     then Exit else Invites.Next;
  Invites.AppendRecord([I, Nick]);   
end;
function TDataStore.UserCount(var Invis, Ops, Login: Integer): Integer;
begin
  Result := 0; Invis := 0; Login := 0; Ops := 0;
  Users.First;
  while not Users.Eof do
  begin
    Inc(Result);
    If (UsersINVISIBLE.AsBoolean) then Inc(Invis);
    If (atoi(UsersLOGIN.AsString) > 1) then Inc(Login);
    If (UsersOper.AsBoolean) then Inc(Ops);
    Users.Next;
  end;
end;
function TDataStore.GetChansCount: Integer;
begin
  Result := 0;
  Channels.First;
  while not Channels.Eof do
  begin
    Inc(Result);
    Channels.Next;
  end;
end;
function TDataStore.GetWhoList(Nick, Who: String; O: Boolean): TStringList;
var I, Li: Integer;
    CNick, LNick: String;
procedure WhoInfo(Nick: String; Ch: String; Voice, O: boolean; var Result: TStringList);
var UInfo: TUserInfo;
    S: String;
    Add: String;
begin
  UInfo := GetUserInfo(Nick);
  If O then S := '@' else
     if Voice then S := '+' else
        S := '';
  Add := '';
  If UInfo.OPER then Add := '*';
  If UInfo.INVISIBLE then Add := Add + 'i';
  If UInfo.WALLOP then Add := Add + 'w';
  S := 'H'+Add+S;
  If (UInfo.ID <> 0) and (not UInfo.Invisible) then Result.Add(UInfo.Nick+' '+Format('%s %s %s %s %s %s :1 %s', ['#'+Ch, UInfo.UserId, UInfo.hostname, ServerName, UInfo.Nick, S, UInfo.RealName]));
end;
begin
  Result := TStringList.Create;
  ChanUsers.First;
  Li := 0; LNick := '';
  while not ChanUsers.Eof do
  begin
    CNick := ChanUsersNick.AsString;
    I := atoi(ChanUsersChannel.AsString);
    If (LowerCase(CNick) = LNick) then
      WhoInfo(CNick, GetChannelName(I), ChanUsersVoice.AsBoolean, ChanUsersOper.AsBoolean, Result)
    else
      If (Li = I) and (EqualNames(Who, CNick)) then
      begin
        If (ChanUsersOper.AsBoolean) then
        begin
          WhoInfo(CNick, GetChannelName(I), ChanUsersVoice.AsBoolean, true, Result);
          LNick := CNick;
        end else if not O then
        begin
          WhoInfo(CNick, GetChannelName(I), ChanUsersVoice.AsBoolean, false, Result);
          LNick := CNick;
        end;
      end else
      If (EqualNames(Who, CNick)) then
      begin
        If (ChanUsersOper.AsBoolean) then
        begin
          WhoInfo(CNick, GetChannelName(I), ChanUsersVoice.AsBoolean, true, Result);
          LNick := CNick;
          Li := I;
        end else if not O then
        begin
          WhoInfo(CNick, GetChannelName(I), ChanUsersVoice.AsBoolean, false, Result);
          LNick := CNick;
          Li := I;
        end;
      end;
    ChanUsers.Next;
  end;
end;
function TDataStore.GetChannelName(I: Integer): String;
begin
  Channels.First;
  while not Channels.Eof do
    If atoi(ChannelsId.AsString) = I then
    begin
      Result := ChannelsName.AsString;
      Exit;
    end else Channels.Next;
  Result := '';
end;
function TDataStore.GetOper(Nick: String): TOperInfo;
begin
  Opers.First;
  Nick := LowerCase(Nick);
  while not Opers.Eof do
  begin
    If LowerCase(OpersNick.AsString) = Nick then
    begin
      Result.NAME := OpersNick.AsString;
      Result.PASS := OpersPassWord.AsString;
      Result.HOSTMASK := OpersHOSTMASK.AsString;
      Result.FLAGS := OpersMODE.AsString;
      Exit;
    end else Opers.Next;
  end;
  Result.NAME := '';
end;
procedure TDataStore.SetOper(Nick: String; OInfo: TOperInfo);
begin
  Opers.First;
  Nick := LowerCase(Nick);
  while not Opers.Eof do
    If LowerCase(OpersNick.AsString) = Nick then
    begin
      Opers.Edit;
      OpersNick.AsString := OInfo.NAME;
      OpersPassWord.AsString := OInfo.PASS;
      OpersHOSTMASK.AsString := OInfo.HOSTMASK;
      OpersMODE.AsString := OInfo.FLAGS;
      Opers.Post;
      Exit;
    end else Opers.Next;
end;
procedure TDataStore.AddOper(OInfo: TOperInfo);
begin
  Opers.AppendRecord([OInfo.Name, OInfo.HostMask, OInfo.Pass, OInfo.Flags]);
end;
procedure TDataStore.DelOper(Nick: String);
begin
  Opers.First;
  Nick := LowerCase(Nick);
  while not Opers.Eof do
    If LowerCase(OpersNick.AsString) = Nick then
    begin
      Opers.Delete;
      Exit;
    end else Opers.Next;
end;
function TDataStore.BecomeOper(Nick, UserId, Host, Name, Pass: String; var Flags: String): byte;
var OInfo: TOperInfo;
    UID, HST: String;
    U, H: boolean;
begin
  OInfo := GetOper(Name);
  If OInfo.NAME <> '' then
  begin
    If Pass <> OInfo.PASS then
    begin
      Result := 2;
      Exit;
    end;
    HST := OInfo.HostMask;
    If (CharInString('@', HST) > 0) then
    begin
      UID := Copy(HST, 1, Pos('@', HST)-1);
      Delete(HST, 1, Length(UID)+1);
    end else UID := '';
    If (UID = '') or (UID = '*') or (UID = UserId) then U := true else U := false;  
    If EqualHosts(Host, HST) then H := true else H := false;
    If not (H and U) then
    begin
      Result := 3;
      Exit;
    end;
    Flags := OInfo.Flags;
    Result := 1;
  end else Result := 0;
end;
procedure TDataStore.UpdateTime(Socket: Integer);
begin
  If FindUserId(Socket) <> 0 then
  begin
    Users.Edit;
    UsersTime.AsString := itoa(GetIrcTime);
    Users.Post;
  end;
end;
function TDataStore.GetTime(Socket: Integer): DWORD;
begin
  If FindUserId(Socket) <> 0 then
    Result := atoi(UsersTime.AsString)
  else Result := 0;
end;
function TDataStore.GetUsersFlag(Flag: Char): TStringList;
var CurFlag: String;
begin
  Result := TStringList.Create;
  Users.First;
  while not Users.Eof do
  begin
    CurFlag := UsersExtMode.AsString;
    if UsersInvisible.AsBoolean then CurFlag := CurFlag + 'i';
    if UsersOper.AsBoolean then CurFlag := CurFlag + 'o';
    if UsersWallop.AsBoolean then CurFlag := CurFlag + 'w';
    If CharInString(Flag, CurFlag) > 0 then Result.Add(UsersSocket.AsString);
    Users.Next;
  end;
end;
function TDataStore.GetUChans(Nick: String): String;
begin
  Result := '';
  ChanUsers.First;
  Nick := LowerCase(Nick);
  while not ChanUsers.Eof do
  begin
    If LowerCase(ChanUsersNick.AsString) = Nick then
    begin
      If Result <> '' then Result := Result + ' ';
      If (ChanUsersOper.AsBoolean) then Result := Result + '@'
        else If (ChanUsersVoice.AsBoolean) then Result := Result + '+';
      Result := Result + GetChannelName(atoi(ChanUsersChannel.AsString));  
    end;
    ChanUsers.Next;
  end;
end;
function TDataStore.GetUsers(Oper: boolean): TStringList;
begin
  Result := TStringList.Create;
  Users.First;
  while not Users.Eof do
  begin
    if not (UsersInvisible.AsBoolean and not Oper) then
      Result.Add(UsersUserId.AsString+' '+'pts/1'+' '+UsersHostname.AsString);
    Users.Next;
  end;
end;
function TDataStore.GetRegistredUserInfo(Nick: String): TRegUserInfo;
begin
  RegUsers.First;
  while not RegUsers.Eof do
    if LowerCase(Nick) <> LowerCase(RegUsersNick.AsString) then RegUsers.Next
      else
    begin
       Result.ID := RegUsersID.AsInteger;
       Result.Nick := RegUsersNick.AsString;
       Result.UserID := RegUsersUserId.AsString;
       Result.HostName := RegUsersHostName.AsString;
       Result.KILL := RegUsersKill.AsBoolean;
       Result.MForward := RegUsersMForward.AsBoolean;
       Result.MLock := RegUsersMLock.AsBoolean;
       Result.MReceipts := RegUsersMReceipts.AsBoolean;
       Result.NoMemo := RegUsersNoMemo.AsBoolean;
       Result.NoOp := RegUsersNoOp.AsBoolean;
       Result.Secure := RegUsersSecure.AsBoolean;
       Result.ShowEmail := RegUsersShowEmail.AsBoolean;
       Result.URL := RegUsersURL.AsString;
       Result.PASSWD := RegUsersPasswd.AsString;
       Result.EMail := RegUsersEmail.AsString;
       Result.Forward_ := RegUsersForward.AsString;
       exit;
    end;
  Result.ID := 0;
end;
procedure TDataStore.SetRegistredUserInfo(Nick: String; Info: TRegUserInfo);
var Id: Integer;
procedure SetValues;
begin
   RegUsersID.AsInteger        := Id;
   RegUsersNick.AsString       := Nick;
   RegUsersUserId.AsString     := Info.UserId;
   RegUsersHostName.AsString   := Info.HostName;
   RegUsersKill.AsBoolean      := Info.Kill;
   RegUsersMForward.AsBoolean  := Info.MForward;
   RegUsersMLock.AsBoolean     := Info.MLock;
   RegUsersMReceipts.AsBoolean := Info.MReceipts;
   RegUsersNoMemo.AsBoolean    := Info.NoMemo;
   RegUsersNoOp.AsBoolean      := Info.NoOp;
   RegUsersSecure.AsBoolean    := Info.Secure;
   RegUsersShowEmail.AsBoolean := Info.ShowEMail;
   RegUsersURL.AsString        := Info.URL;
   RegUsersPasswd.AsString     := Info.Passwd;
   RegUsersEmail.AsString      := Info.EMail;
   RegUsersForward.AsString    := Info.Forward_;
end;
begin
  RegUsers.First;
  Id := 0;
  while not RegUsers.Eof do
  begin
    if LowerCase(RegUsersNick.AsString) <> LowerCase(Nick) then
     if Id < RegUsersId.AsInteger then ID := RegUsersId.AsInteger + 1
    else else begin Id := RegUsersId.AsInteger; SetValues; exit; end;
    RegUsers.Next;
  end;
  if Id = 0 then Id := 1;
  RegUsers.Append; 
  SetValues;
end;
function TDataStore.GetGhostInfo(Nick: String): TGhostInfo;
begin
  Reg_Users.First;
  while not Reg_Users.Eof do
   if LowerCase(Reg_UsersNick.AsString) <> LowerCase(Nick) then Reg_Users.Next
  else begin
    Result.ID      := Reg_UsersID.AsInteger;
    Result.Nick    := Reg_UsersNick.AsString;
    Result.Status  := Reg_UsersStatus.AsInteger;
    Result.TimeOut := Reg_UsersTimeOut.AsInteger;
    Result.Kill    := Reg_UsersKill.AsBoolean;
    Exit;
  end;
  Result.Id := 0;
end;
procedure TDataStore.SetGhostInfo(Nick: String; Info: TGhostInfo);
var Id: Integer;
procedure SetValues;
begin
  Reg_UsersID.AsInteger     := Id;
  Reg_UsersNick.AsString    := Nick;
  Reg_UsersStatus.AsInteger := Info.Status;
  Reg_UsersTimeOut.AsInteger:= Info.TimeOut;
  Reg_UsersKill.AsBoolean   := Info.Kill;
end;
begin
  Reg_Users.First;
  Id := 0;
  while not Reg_Users.Eof do
  begin
    if LowerCase(Reg_UsersNick.AsString) <> LowerCase(Nick) then
      if Id < Reg_UsersId.AsInteger then Id := Reg_UsersId.AsInteger + 1 else
    else begin Id := Reg_UsersId.AsInteger; SetValues; exit; end;
    Reg_Users.Next;
  end;
  if Id = 0 then Id := 1;
  Reg_Users.Append;
  SetValues;
end;
function TDataStore.IsKillGhost: Boolean;
begin
  Reg_Users.First;
  Result := false;
  while not Reg_Users.Eof do
    if Reg_UsersKill.AsBoolean and (Reg_UsersTimeOut.AsInteger > 0) then
    begin
       Result := true;
       Exit;
    end else Reg_Users.Next;
end;
initialization
  DataDir := ExtractFilePath(ParamStr(0));
  Delete(DataDir, Length(DataDir), 1);
  while (Length(DataDir) > 0) and (DataDir[Length(DataDir)] <> '\') do
    Delete(DataDir, Length(DataDir), 1);
  DataDir := DataDir + 'DB\';
end.
