unit helpserv;
interface
  uses Windows, Classes, SysUtils;
  var StartHelpDir: String;
  function Help(Cmd: String; Var found: boolean): TStringList;
implementation
function GetHelpFilePath(Cmd: String): String; // Return path to help file
var AddPath: String;
begin
  Result := StartHelpDir;
  AddPath := '';
  if Cmd = '' then Cmd := 'default';
  while (Length(Cmd) > 0) and (Cmd[Length(Cmd)] = ' ') do Delete(Cmd, Length(Cmd), 1);
  while Pos(' ', Cmd) > 0 do
    if Cmd[1] <> ' ' then 
    begin
      AddPath := AddPath + Cmd[1];
      Delete(Cmd, 1, 1);
    end else begin
      AddPath := AddPath + '\';
      while (Length(Cmd) > 0) and (Cmd[1] = ' ') do Delete(Cmd, 1, 1);
    end;
  if AddPath = '' then AddPath := 'helpserv';
  Result := Result + AddPath + '\' + Cmd + '.ph_';
end;
function Help(Cmd: String; Var found: boolean): TStringList;
begin
  found := true;
  Result := TStringList.Create;
  Cmd := GetHelpFilePath(Cmd);
  if FileExists(Cmd) then Result.LoadFromFile(Cmd) else found := false;
end;

initialization
  StartHelpDir := ExtractFilePath(ParamStr(0));
  Delete(StartHelpDir, Length(StartHelpDir), 1);
  while (Length(StartHelpDir) > 0) and (StartHelpDir[Length(StartHelpDir)] <> '\') do
    Delete(StartHelpDir, Length(StartHelpDir), 1);
  StartHelpDir := StartHelpDir + 'DB\HELP\';
end.