unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, datast, types, ScktComp, irc_const, Db, Grids, DBGrids,
  ExtCtrls, DBCtrls, MyTime, ComCtrls, ImgList, Menus, WSocket, Winsock, fingerThrd;

type
  TMainForm = class(TForm)
    pircds: TServerSocket;
    PageControl1: TPageControl;
    GeneralTab: TTabSheet;
    OperTab: TTabSheet;
    GroupBox1: TGroupBox;
    OperList: TListView;
    ImageList1: TImageList;
    OperMenu: TPopupMenu;
    EditProperties1: TMenuItem;
    AddOper1: TMenuItem;
    DelOperator1: TMenuItem;
    PingTimer: TTimer;
    ChannelMenu: TPopupMenu;
    Detailedinfo1: TMenuItem;
    N1: TMenuItem;
    Users1: TMenuItem;
    GroupBox2: TGroupBox;
    ChanList: TListView;
    FingerSocket: TWSocket;
    GhostTimer: TTimer;
    procedure pircdsClientRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure pircdsClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure pircdsClientError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure OperTabShow(Sender: TObject);
    procedure EditProperties1Click(Sender: TObject);
    procedure AddOper1Click(Sender: TObject);
    procedure DelOperator1Click(Sender: TObject);
    procedure OperListDblClick(Sender: TObject);
    procedure PingTimerTimer(Sender: TObject);
    procedure Detailedinfo1Click(Sender: TObject);
    procedure Users1Click(Sender: TObject);
    procedure ChanListDblClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FingerSocketSessionAvailable(Sender: TObject; Error: Word);
    procedure FormDestroy(Sender: TObject);
    procedure GhostTimerTimer(Sender: TObject);
  private
    function GetThread: TFingerThread;
  public
    function GetSocketByHandle(Socket: Integer): TCustomWinSocket;
    procedure DoCommand(Socket: Integer; Str: String);
    procedure WriteCl(Socket: Integer; Str: String; Const Prefix: boolean = true);
    procedure WriteAll(Str: String); overload;
//  procedure WriteAll(Str: String; Socket: Integer); overload;
    procedure MakeNick(Socket: Integer; Arg: String);
    procedure MakeUser(Socket: Integer; Arg: String);
    procedure MakeWellcome(Socket: Integer; Nick: String);
    procedure MakeJoin(Socket: Integer; Arg: String);
    procedure MakeNames(Socket: Integer; Arg: String);
    procedure MakeTopic(Socket: Integer; Arg: String);
    procedure MakeMotd(Socket: Integer; Arg: String);
    procedure MakeMsg(Socket: Integer; Cmd, Arg: String);
    procedure WriteChan(Socket: Integer; Ch, Msg: String);
    procedure MakeUserhost(Socket: Integer; Arg: String);
    procedure MakeInfo(Socket: Integer; Arg: String);
    procedure MakeMode(Socket: Integer; Arg: String);
    procedure ChannelMode(Socket: Integer; Rcpt, Flags, Nick: String);
    procedure MakeChBan(Socket: Integer; Nick, Rcpt, Arg: String; Add, OnCh, Oper: Boolean);
    procedure MakeChOper(Socket: Integer; Nick, Rcpt, Arg: String; Add, OnCh, Oper: Boolean);
    procedure MakeChVoice(Socket: Integer; Nick, Rcpt, Arg: String; Add, OnCh, Oper: Boolean);
    procedure UserMode(Socket: Integer; Rcpt, Flags, Nick: String);
    procedure MakePart(Socket: Integer; Arg: String);
    procedure MakeQuit(Socket: Integer; Arg: String);
    procedure MakeList(Socket: Integer; Arg: String);
    procedure MakeInvite(Socket: Integer; Arg: String);
    procedure MakeKick(Socket: Integer; Arg: String);
    procedure MakeLusers(Socket: Integer; Arg: String);
    procedure MakeWho(Socket: Integer; Arg: String);
    procedure MakeOper(Socket: Integer; Arg: String);
    procedure MakeTime(Socket: Integer; Arg: String);
    procedure MakeKill(Socket: Integer; Arg: String);
    procedure MakeVersion(Socket: Integer; Arg: String);
    procedure MakeSamode(Socket: Integer; Arg: String);
    procedure ChannelSAMode(Socket: Integer; Rcpt, Flags: String; UInfo: TUserInfo);
    procedure WriteFlag(Msg: String; Flag: char);
    procedure MakeWallops(Socket: Integer; Arg: String);
    procedure MakeIsOn(Socket: Integer; Arg: String);
    procedure MakeAway(Socket: Integer; Arg: String);
    procedure MakeWhois(Socket: Integer; Arg: String);
    procedure MakeAdmin(Socket: Integer; Arg: String);
    procedure MakeUsers(Socket: Integer; Arg: String);
    procedure do_refresh_list; // 31.03.00
    procedure MakeHelp(Socket: Integer; Arg: String);
  end;

var
  MainForm: TMainForm;
implementation

uses opers, _chan_pr, _user_pr, helpserv, nickserv;

{$R *.DFM}
var Connections: array[1..65535] of ^String;
//Login const
Const lgNick = 2;
      lgUser = 1;
      lgNone = 0;
      lgFull = (lgNick or lgUser);
      lgWelc = 4;
//End of
function TMainForm.GetSocketByHandle(Socket: Integer): TCustomWinSocket;
var I: Integer;
begin
  For I := 1 to pircds.Socket.ActiveConnections do
    If (pircds.Socket.Connections[I-1].SocketHandle = Socket) then
    begin
      Result := pircds.Socket.Connections[I-1];
      Exit;
    end;
  Result := nil;
end;
procedure TMainForm.pircdsClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var Recv, Cmd: String;
    SHandle: Integer;
begin
 Recv := Socket.ReceiveText;
 SHandle := Socket.SocketHandle;
 if Connections[SHandle] <> nil
  then Recv := Connections[SHandle]^ + Recv;
 while pos(#$A, Recv) > 0 do
 begin
   Cmd := Copy(Recv, 1, Pos(#$A, Recv)-1);
   If (Length(Cmd) > 0) and (Cmd[Length(Cmd)]=#$D) then
    Delete(Cmd, Length(Cmd), 1);
   DoCommand(SHandle, Cmd);
   Delete(Recv, 1, Length(Cmd));
   While (Pos(#$D, Recv) = 1) or (Pos(#$A, Recv) = 1) do
    Delete(Recv, 1, 1);
 end;
 if Connections[SHandle] <> nil then
    dispose(Connections[SHandle]);
  new(Connections[SHandle]);
  Connections[SHandle]^ := Recv;
end;

procedure TMainForm.pircdsClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
var User: String;
begin
 User := DataStore.UserBySocket(Socket.SocketHandle);
 DataStore.DelUser(Socket.SocketHandle);
 If Connections[Socket.SocketHandle] <> nil then
 begin
    dispose(Connections[Socket.SocketHandle]);
    Connections[Socket.SocketHandle]:= nil;
 end;
 If Assigned(Socket) then Socket.Destroy;
 WriteAll(Format(':%s QUIT %s', [User, ':Connection reset by peer.']));
end;
//********************************************************//
procedure TMainForm.DoCommand(Socket: Integer; Str: String);
var Cmd, Arg: String;
    Err: String;
begin
 If Pos(' ', Str) > 0 then
 begin
   Cmd := Copy(Str, 1, Pos(' ', Str)-1);
   Delete(Str, 1, Length(Cmd)+1);
   Arg := Str;
 end else Cmd := Str;
 DataStore.UpdateTime(Socket);
 Cmd := LowerCase(Cmd);
 If Cmd = 'nick' then
 begin
   MakeNick(Socket, Arg);
   Exit;
 end;
 If Cmd = 'user' then
 begin
   MakeUser(Socket, Arg);
   Exit;
 end;
 If Cmd = 'join' then
 begin
   MakeJoin(Socket, Arg);
   Exit;
 end;
 iF Cmd = 'names' then
 begin
   MakeNames(Socket, Arg);
   Exit;
 end;
 If Cmd = 'topic' then
 begin
   MakeTopic(Socket, Arg);
   Exit;
 end;
 If Cmd = 'motd' then
 begin
   MakeMotd(Socket, Arg);
   Exit;
 end;
 If (Cmd = 'privmsg') or (Cmd = 'notice') then
 begin
   MakeMsg(Socket, Cmd, Arg);
   Exit;
 end;
 If (Cmd = 'userhost') then
 begin
   MakeUserhost(Socket, Arg);
   Exit;
 end;
 If (Cmd = 'info') then
 begin
   MakeInfo(Socket, Arg);
   Exit;
 end;
 If (Cmd = 'mode') then
 begin
   MakeMode(Socket, Arg);
   Exit;
 end;
 If (Cmd = 'part') then
 begin
   MakePart(Socket, Arg);
   Exit;
 end;
 If (Cmd = 'quit') then
 begin
   MakeQuit(Socket, Arg);
   Exit;
 end;
 If (Cmd = 'list') then
 begin
   MakeList(Socket, Arg);
   Exit;
 end;
 If (Cmd = 'invite') then
 begin
   MakeInvite(Socket, Arg);
   Exit;
 end;
 If (Cmd = 'kick') then
 begin
   MakeKick(Socket, Arg);
   Exit;
 end;
 If (Cmd = 'lusers') then
 begin
   MakeLusers(Socket, Arg);
   Exit;
 end;
 If (Cmd = 'who') then
 begin
   MakeWho(Socket, Arg);
   Exit;
 end;
 If (Cmd = 'oper') then
 begin
   MakeOper(Socket, Arg);
   Exit;
 end;
 if (Cmd = 'pong') then Exit;
 if (Cmd = 'ping') then
 begin
   WriteCl(Socket, 'PONG :'+ServerName, false);
   Exit;
 end;
 if (Cmd = 'time') then
 begin
   MakeTime(Socket, Arg);
   Exit;
 end;
 If (Cmd = 'kill') then
 begin
   MakeKill(Socket, Arg);
   Exit;
 end;
 If (Cmd = 'version') then
 begin
   MakeVersion(Socket, Arg);
   Exit;
 end;
 If (Cmd = 'samode') then
 begin
   MakeSamode(Socket, Arg);
   Exit;
 end;
 If (Cmd = 'wallops') then
 begin
   MakeWallops(Socket, Arg);
   Exit;
 end;
 If (Cmd = 'ison') then
 begin
   MakeIsOn(Socket, Arg);
   Exit;
 end;
 If (Cmd = 'away') then
 begin
   MakeAway(Socket, Arg);
   Exit;
 end;
 If (Cmd = 'whois') then
 begin
   MakeWhois(Socket, Arg);
   Exit;
 end;
 If (Cmd = 'admin') then
 begin
   MakeAdmin(Socket, Arg);
   Exit;
 end;
 If (Cmd = 'users') then
 begin
   MakeUsers(Socket, Arg);
   Exit;
 end;
 If (Cmd = 'help') or (Cmd = 'helpop') or (Cmd = 'helpserv') or (Cmd = 'hs') then
 begin
   MakeHelp(Socket, Arg);
   Exit;
 end; 
 If (Cmd = 'ns') or (Cmd = 'nickserv') then
 begin
   NS(Socket, Arg);
   Exit;
 end;
 Err := Format('%d * '+MSG_UNKNOWNCOMMAND, [ERR_UNKNOWNCOMMAND, CMD]);
 WriteCl(Socket, Err);
end;
//********************************************************//
procedure TMainForm.WriteCl(Socket: Integer; Str: String; Const Prefix: boolean = true);
var pfix: String;
begin
  pfix := ServerName;
  If Prefix then GetSocketByHandle(Socket).SendText(':'+pfix + ' '+Str + #$D#$A)
    else GetSocketByHandle(Socket).SendText(Str + #$D#$A);
end;
procedure TMainForm.MakeNick(Socket: Integer; Arg: String);
var Nick{, hopcount}: String;
    Answer, OldNick, UserId: String;
    UInfo: TUserInfo;
begin
 Nick := Arg;
 If not ((Length(Nick) > 0) and (Nick[1] <> ':')) then Delete(Nick, 1, 1);
 If pos(' ', Nick) > 0 then Nick := Copy(Nick, 1, Pos(' ', Nick)-1);
 If (Nick = '') then
 begin
   Answer := Format('%d * '+MSG_NONICKNAMEGIVEN, [ERR_NONICKNAMEGIVEN]);
   WriteCl(Socket, Answer);
   Exit;
 end;
 If not NickCheck(Nick, NICKLEN) then
 begin
   Answer := Format('%d * '+MSG_ERRONEUSNICKNAME, [ERR_ERRONEUSNICKNAME, Nick]);
   WriteCl(Socket, Answer);
   Exit;
 end;
 If (not DataStore.IsOn(Nick)) or (DataStore.FindUserId(Nick) = DataStore.FindUserId(Socket)) then
 begin
  If (DataStore.FindUserId(Socket) = 0) then
   if not DataStore.AddUser(Nick, Socket) then
   begin
     Answer := Format('%d * '+MSG_NICKNAMEINUSE, [ERR_NICKNAMEINUSE, Nick]);
     WriteCl(Socket, Answer);
     Exit;
   end;
   UInfo := DataStore.GetUserInfo(Socket);
   OldNick := UInfo.NICK;
   UserId := UInfo.USERID;
   UInfo.NICK := Nick;
   UInfo.Login := (UInfo.Login or lgNick);
   If ((UInfo.Login and lgWelc) = lgWelc) then WriteAll(':'+OldNick+'!'+UserId+' NICK :'+Nick);
   If ((UInfo.Login and lgFull) = lgFull) and ((UInfo.Login and lgWelc) = 0) then 
   begin
     UInfo.Login := (UInfo.Login or lgWelc);
     DataStore.SetUserInfo(Socket, UInfo);
     MakeWellcome(Socket, Nick);
     NewNick(Socket);
   end else begin DataStore.SetUserInfo(Socket, UInfo); NewNick(Socket); end
 end else
 begin
   Answer := Format('%d * '+MSG_NICKNAMEINUSE, [ERR_NICKNAMEINUSE, Nick]);
   WriteCl(Socket, Answer);
   Exit;
 end;
//ERR_NICKCOLLISION
end;
procedure TMainForm.MakeUser(Socket: Integer; Arg: String);
var uname, hostname, server, rname: String;
    UInfo: TUserInfo;
    I: byte;
begin
  If (CharInString(' ', Arg) < 3) or (CharInString(':', Arg) = 0) then
  begin
    uname := Format('%d * '+MSG_NEEDMOREPARAMS, [ERR_NEEDMOREPARAMS, 'USER']);
    WriteCl(Socket, uname);
    Exit;
  end;
  for i := 1 to 3 do
  begin
    rname := Copy(Arg, 1, pos(' ', Arg)-1);
    Delete(Arg, 1, Length(rname)+1);
    case i of
     1: uname := rname;
     2: hostname := rname;
     3: server := rname;
    end;
  end;
  rname := Arg;
  If rname[1] = ':' then Delete(rname, 1, 1);
  If ((DataStore.GetUserInfo(Socket).Login and lgUser) = lgUser) then
  begin
    WriteCl(Socket, Format('%d * '+MSG_ALREADYREGISTRED, [ERR_ALREADYREGISTRED]));
    Exit;
  end;
  If (DataStore.FindUserId(Socket) = 0) then DataStore.AddUser('', Socket);
  UInfo := DataStore.GetUserInfo(Socket);
  UInfo.USERID := uname;
  UInfo.HOSTNAME := GetSocketByHandle(Socket).RemoteHost;
  UInfo.REALNAME := rname;
  UInfo.LOGIN := (UInfo.LOGIN or lgUser);
  If ((UInfo.Login and lgFull) = lgFull) and ((UInfo.Login and lgWelc) = 0) then 
  begin
    UInfo.Login := (UInfo.Login or lgWelc);
    DataStore.SetUserInfo(Socket, UInfo);
    MakeWellcome(Socket, UInfo.NICK);
  end else DataStore.SetUserInfo(Socket, UInfo);
end;
procedure TMainForm.MakeWellcome(Socket: Integer; Nick: String);
begin
//RPL_WELCOME
  WriteCl(Socket, Format('%s %s :Welcome to the IRC Network %s', ['001', Nick, DataStore.UserBySocket(Socket)]));
//RPL_YOURHOST
  WriteCl(Socket, Format('%s %s :Your host is %s, running version %s', ['002', Nick, pircds.Socket.Localhost, '1.0']));
//RPL_CREATED
  WriteCl(Socket, Format('%s %s :This server was created %s', ['003', Nick, '10 Nov 1999 Tue']));
//RPL_MYINFO
  WriteCl(Socket, Format('%s %s %s %s oiwsg biklmnopstv', ['004', Nick, 'PIRCD', '1.0']));
  MakeLusers(Socket, '');
  MakeMotd(Socket, '');
end;
procedure TMainForm.WriteAll(Str: String);
var I: Integer;
begin
  For I := 1 to pircds.Socket.ActiveConnections do
    if DataStore.FindUserId(pircds.Socket.Connections[I-1].SocketHandle) <> 0 then
       pircds.Socket.Connections[I-1].SendText(Str + #$D#$A);
end;
procedure TMainForm.pircdsClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  ErrorCode := 0;
  pircdsClientDisconnect(Sender, Socket)
end;

procedure TMainForm.MakeJoin(Socket: Integer; Arg: String);
 var Nick, UserId, Host: String;
     Chans, Keys, Chan, Key: String;
     ChInfo: TChannelInfo;
     UInfo: TUserInfo;
     Item: TListItem; //31.03.00
 procedure JoinTo(Ch, Key: String; oper, invis: boolean);
 begin
   case DataStore.AddToChan(Nick, Ch, Key) of
    0: WriteCl(Socket, Format('%d %s ' + MSG_NOSUCHCHANNEL, [ERR_NOSUCHCHANNEL, Nick, Ch]));
    1: begin
         if (not Invis) then WriteChan(0, Ch, Format(':%s!%s@%s JOIN :#%s',[Nick, UserId, Host, Ch]))
           else WriteCl(Socket, Format(':%s!%s@%s JOIN :#%s',[Nick, UserId, Host, Ch]), false);
         if oper then DataStore.MakeOper(Ch, Nick, true);
         MakeNames(Socket, '#'+Ch);
         MakeTopic(Socket, '#'+Ch);
       end;
    2: WriteCl(Socket, Format('%d %s '+MSG_BANNEDFROMCHAN, [ERR_BANNEDFROMCHAN, Nick, Ch]));
    3: WriteCl(Socket, Format('%d %s '+MSG_INVITEONLYCHAN, [ERR_INVITEONLYCHAN, Nick, Ch]));
    5: WriteCl(Socket, Format('%d %s '+MSG_BADCHANNELKEY, [ERR_BADCHANNELKEY, Nick, Ch]));
    6: WriteCl(Socket, Format('%d %s '+MSG_CHANNELISFULL, [ERR_CHANNELISFULL, Nick, Ch]));
   end;
 end;
begin
{
  ERR_TOOMANYCHANNELS
}
  UInfo := DataStore.GetUserInfo(Socket);
  Nick := UInfo.NICK;
  UserId := UInfo.USERID;
  Host := UInfo.HOSTNAME;
  Keys := '';
  If pos(' ', Arg) > 0 then
  begin
    Chans := Copy(Arg, 1, Pos(' ', Arg)-1);
    Delete(Arg, 1, Length(Chans)+1);
    Keys := Arg;
  end else Chans := Arg;
  while Length(Chans) > 0 do
  begin
    If (CharInString(',', Chans) > 0) then
    begin
      Chan := Copy(Chans, 1, Pos(',', Chans)-1);
      Delete(Chans, 1, Length(Chan)+1);
    end else begin Chan := Chans; Chans := ''; end;
    If (CharInString(',', Keys) > 0) then
    begin
      Key := Copy(Keys, 1, pos(',', Keys)-1);
      Delete(Keys, 1, Length(Key)+1);
    end else begin Key := Keys; Keys := ''; end;
    If (Length(Chan) > 0) and ((Chan[1] <> '#') and (Chan[1] <> '&')) then
      JoinTo(Chan, Key, false, UInfo.Invisible) else
      begin
        Delete(Chan, 1, 1);
        If (Length(Chan) > 0) and (NickCheck(Chan, CHANNELLEN)) then
        begin
           If (DataStore.FindChannelId(Chan) = 0) then
           begin
              DataStore.AddChannel(Chan);
              ChInfo := DataStore.GetChannelInfo(Chan);
              ChInfo.CTIME := GetIrcTime;
              DataStore.SetChannelInfo(Chan, ChInfo);
              JoinTo(Chan, Key, true, UInfo.Invisible);
              //31.03.00
                Item := ChanList.Items.Add;
                Item.ImageIndex := 1;
                Item.Caption := Chan;
                Item.SubItems.Add(ChInfo.FLAGS);
                Item.SubItems.Add('1');
              //
           end else JoinTo(Chan, Key, false, UInfo.Invisible);
        end else WriteCl(Socket, Format('%d %s :Bad channel mask', [ERR_NEEDMOREPARAMS, Nick]));
      end;
  end;
end;
procedure TMainForm.MakeNames(Socket: integer; Arg: String);
var Old, Chan, Nick: String;
    NList: TStringList;
begin
 // Add for all
 Nick := DataStore.NickBySocket(Socket);
 If Arg = '*' then Arg := '';
 If Arg = '' then
 begin
   NList := DataStore.GetNames(Nick, '');
   While NList.Count > 0 do
   begin
     WriteCl(Socket, Format('%d %s '+MSG_NAMREPLY, [RPL_NAMREPLY, Nick, '#'+NList.Names[0], NList.Values[NList.Names[0]]]));
     WriteCl(Socket, Format('%d %s '+MSG_ENDOFNAMES, [RPL_ENDOFNAMES, Nick, '#'+NList.Names[0]]));
     NList.Delete(0);
   end;
   NList.Free;
   Exit;
 end;
 while Length(Arg) > 0 do
 begin
   If CharInString(',', Arg) > 0 then
   begin
     Chan := Copy(Arg, 1, Pos(',', Arg) - 1);
     Delete(Arg, 1, Length(Chan)+1);
   end else begin Chan := Arg; Arg := ''; end;
   Old := Chan;
   If (Length(Chan) > 0) and ((Chan[1] = '#') or (Chan[1] = '&')) then
      Delete(Chan, 1, 1) else Chan := '';
   If (Chan <> '') then
   begin
     NList := DataStore.GetNames(Nick, Chan);
     If NList.Count > 0 then
     begin
       WriteCl(Socket, Format('%d %s '+MSG_NAMREPLY, [RPL_NAMREPLY, Nick, '#'+NList.Names[0], NList.Values[NList.Names[0]]]));
       WriteCl(Socket, Format('%d %s '+MSG_ENDOFNAMES, [RPL_ENDOFNAMES, Nick, '#'+NList.Names[0]]));
     end;  
     NList.Free;
   end;
 end;
end;
procedure TMainForm.MakeTopic(Socket: Integer; Arg: String);
var Old, Chan, Topic: String;
    ChInfo: TChannelInfo;
    Nick, UserId, UserHost: String;
    UInfo: TUserInfo;
begin
  UInfo := DataStore.GetUserInfo(Socket);
  Nick := UInfo.NICK;
  UserId := UInfo.USERID;
  UserHost := UInfo.HOSTNAME;
  if (Length(Arg) > 0) then
    If (CharInString(':', Arg) > 0) then
    begin // Set topic
       Chan := Copy(Arg, 1, Pos(':', Arg)-1);
       Delete(Arg, 1, Length(Chan)+1);
       Chan := Chop(Chan);
       Topic := Arg;
       If (Length(Chan) > 0) and ((Chan[1] = '#') or (Chan[1] = '&')) then
        Delete(Chan, 1, 1) else Chan := '';
      case DataStore.SetTopic(Chan, Nick, Topic) of
        0: WriteAll(Format(':%s!%s@%s TOPIC #%s :%s', [Nick, UserId, UserHost, Chan, Topic]));
        1: WriteCl(Socket, Format('%d %s '+MSG_NOTONCHANNEL, [ERR_NOTONCHANNEL, Nick, '#'+Chan]));
        2: WriteCl(Socket, Format('%d %s '+MSG_CHANOPRIVSNEEDED, [ERR_CHANOPRIVSNEEDED, Nick, '#'+Chan]));
        3: WriteCl(Socket, Format('%d %s '+MSG_NOSUCHCHANNEL, [ERR_NOSUCHCHANNEL, Nick, '#'+Chan]));
      end;
    end else
     begin // Get topic
       Chan := Chop(Arg);
       Old := Chan;
       If (Length(Chan) > 0) and ((Chan[1] = '#') or (Chan[1] = '&')) then
        Delete(Chan, 1, 1) else Chan := '';
        ChInfo := DataStore.GetChannelInfo(Chan);
       if (Chan <> '') and (LowerCase(Chan) = LowerCase(ChInfo.Name)) then
       begin
         If (ChInfo.TOPIC = '') then
           WriteCl(Socket, Format('%d %s '+MSG_NOTOPIC, [RPL_NOTOPIC, Nick, old])) else
           begin
             WriteCl(Socket, Format('%d %s '+MSG_TOPIC, [RPL_TOPIC, Nick, Old, ChInfo.Topic]));
             WriteCl(Socket, Format('%d %s '+MSG_TOPICTIME, [RPL_TOPICTIME, Nick, Old, Nick, ChInfo.TTime]));
           end;
       end else
       begin
          if Chan <> '' then Old := Chan;
          WriteCl(Socket, Format('%d %s '+MSG_NOSUCHCHANNEL, [ERR_NOSUCHCHANNEL, Nick, Old]));
       end;
     end else WriteCl(Socket, Format('%d %s '+MSG_NEEDMOREPARAMS, [ERR_NEEDMOREPARAMS, Nick, 'TOPIC']));
end;
procedure TMainForm.MakeMotd(Socket: Integer; Arg: String);
var Motd: TStringList;
    Nick: String;
begin
  Nick := DataStore.NickBySocket(Socket);
  Motd := DataStore.Motd;
  If Motd.Count > 0 then
  begin
    WriteCl(Socket, Format('%d %s '+MSG_MOTDSTART, [RPL_MOTDSTART, NICK, ServerName]));
    While (Motd.Count > 0) do
    begin
       WriteCl(Socket, Format('%d %s '+MSG_MOTD, [RPL_MOTD, Nick, Motd.Strings[0]]));
       Motd.Delete(0);
    end;
    WriteCl(Socket, Format('%d %s '+MSG_ENDOFMOTD, [RPL_ENDOFMOTD, Nick]));
  end else WriteCl(Socket, Format('%d %s '+MSG_NOMOTD, [ERR_NOMOTD, Nick]));
  Motd.Free;
end;
procedure TMainForm.MakeMsg(Socket: Integer; Cmd, Arg: String);
var Rcpts, Rcpt, Msg: String;
    FullNick: String;
    UInfo, RInfo: TUserInfo;
begin
   Rcpts := Copy(Arg, 1 , Pos(' ', Arg)-1);
   If Length(Rcpts) > 0 then
   begin
     Delete(Arg, 1, Length(Rcpts)+1);
     Msg := Arg;
   end else Msg := '';
   If Rcpts = '' then
   begin
     If Cmd = 'privmsg' then WriteCl(Socket, Format('%d %s '+MSG_NORECIPIENT, [ERR_NORECIPIENT, DataStore.NickBySocket(Socket), UpperCase(Cmd)]));
     Exit;
   end;
   If Msg = '' then
   begin
     If Cmd = 'privmsg' then WriteCl(Socket, Format('%d %s '+MSG_NOTEXTTOSEND, [ERR_NOTEXTTOSEND, DataStore.NickBySocket(Socket), UpperCase(Cmd)]));
     Exit;
   end;
   UInfo := DataStore.GetUserInfo(Socket);
   FullNick := Format('%s!%s@%s', [UInfo.Nick, UInfo.UserId, UInfo.Hostname]);
   while Length(Rcpts) > 0 do
   begin
     If (CharInString(',', Rcpts) > 0) then
     begin
       Rcpt := Copy(Rcpts, 1, Pos(',', Rcpts)-1);
       Delete(Rcpts, 1, Length(Rcpt)+2);
     end else begin Rcpt := Rcpts; Rcpts := ''; end;
     If (Length(Rcpt) > 0) then
     begin
        If Rcpt[1] = '#' then
        begin
          Delete(Rcpt, 1, 1);
          case DataStore.CanSendChan(Socket, Rcpt) of
           0: WriteChan(Socket, Rcpt, Format(':%s %s %s %s', [FullNick, UpperCase(Cmd),'#'+Rcpt, Msg]));
           1: If Cmd = 'privmsg' then WriteCl(Socket, Format('%d %s '+MSG_NOSUCHNICK, [ERR_NOSUCHNICK, FullNick, '#'+Rcpt]));
           2, 3: If Cmd = 'privmsg' then WriteCl(Socket, Format('%d %s '+MSG_CANNOTSENDTOCHAN, [ERR_CANNOTSENDTOCHAN, FullNick, '#'+Rcpt]));
          end;
        end else
        begin
          RInfo := DataStore.GetUserInfo(Rcpt);
          If (RInfo.ID <> 0) then
          begin
            If (RInfo.Away <> '') and (Cmd = 'privmsg') then
            begin
              WriteCl(Socket, Format('%d %s '+MSG_AWAY, [RPL_AWAY, UInfo.Nick, RInfo.Nick, RInfo.Away]));
              Exit;
            end;
            WriteCl(DataStore.SocketByNick(Rcpt), Format(':%s %s %s %s', [FullNick, UpperCase(Cmd),Rcpt, Msg]), false);
          end else If Cmd = 'privmsg' then WriteCl(Socket, Format('%d %s '+MSG_NOSUCHNICK, [ERR_NOSUCHNICK, FullNick, Rcpt]));
        end;
    end;
   end;
//WildCards = '*', '?' available for opers only
{ERR_NOTOPLEVEL ERR_WILDTOPLEVEL ERR_TOOMANYTARGETS}
end;
procedure TMainForm.WriteChan(Socket: Integer; Ch, Msg: String);
var I: Integer;
    List: TStringList;
    S: Integer;
begin
  List := DataStore.GetUsersSockets(Ch);
  For I := 0 to List.Count - 1 do
  begin
    S := atoi(List.Strings[I]);
    If (S <> 0) and (S <> Socket) then WriteCl(S, Msg, false);
  end;
  List.Free;
end;
procedure TMainForm.WriteFlag(Msg: String; Flag: char);
var I: Integer;
    List: TStringList;
    S: Integer;
begin
  List := DataStore.GetUsersFlag(Flag);
  For I := 0 to List.Count - 1 do
  begin
    S := atoi(List.Strings[I]);
    If (S <> 0) then WriteCl(S, Msg, false);
  end;
  List.Free;
end;
procedure TMainForm.MakeUserhost(Socket: Integer; Arg: String);
var UInfo: TUserInfo;
    Us, Nick: String;
    before: boolean;
begin
  Nick := DataStore.NickBySocket(Socket);
  before := false;
  while Length(Arg) > 0 do
  begin
    If CharInString(' ', Arg) > 0 then
    begin
      Us := Copy(Arg, 1, Pos(' ', Arg)-1);
      Delete(Arg, 1, Length(Us)+1);
    end else begin Us := Arg; Arg := ''; end;
    UInfo := DataStore.GetUserInfo(Us);
    If ((UInfo.ID = 0) and (Arg = '') and (not before)) or (UInfo.ID <> 0) then
    begin
       If (UInfo.Id = 0) then WriteCl(Socket, Format('%d %s '+MSG_USERHOST, [RPL_USERHOST, Nick, Us, ''])) else
       begin
         If UInfo.OPER then Us := Us + '*';
         WriteCl(Socket, Format('%d %s '+MSG_USERHOST, [RPL_USERHOST, Nick, Us, '+'+UInfo.UserId+'@'+UInfo.hostname]));
       end;  
       before := true;
    end;
  end;
  If (not before) then WriteCl(Socket, Format('%d %s '+MSG_NEEDMOREPARAMS, [ERR_NEEDMOREPARAMS, Nick, 'USERHOST']));
end;
procedure TMainForm.MakeInfo(Socket: Integer; Arg: String);
var Info: TStringList;
    Nick: String;
begin
  Info := DataStore.Info;
  Nick := DataStore.NickBySocket(Socket);
  WriteCl(Socket, Format('%d %s '+MSG_INFOSTART, [RPL_INFOSTART, Nick]));
  while Info.Count > 0 do
  begin
    WriteCl(Socket, Format('%d %s '+MSG_INFO, [RPL_INFO, Nick, Info.Strings[0]]));
    Info.Delete(0);
  end;
  WriteCl(Socket, Format('%d %s '+MSG_ENDOFINFO, [RPL_ENDOFINFO, Nick]));
end;
procedure TMainForm.MakeMode(Socket: Integer; Arg: String);
var Rcpt, Flags, Nick: String;
begin
//!!! The most difficult command !!!
 Nick := DataStore.NickBySocket(Socket);
 If (CharInString(' ', Arg) > 0) then
 begin
   Rcpt := Copy(Arg, 1, Pos(' ', Arg)-1);
   Delete(Arg, 1, Length(Rcpt)+1);
   Flags := Arg;
 end else begin Flags := ''; Rcpt := Arg; Arg := ''; end;
 If Length(Rcpt) = 0 then
 begin
   WriteCl(Socket, Format('%d %s '+MSG_NEEDMOREPARAMS, [ERR_NEEDMOREPARAMS, Nick, 'MODE']));
   Exit;
 end;
 If (Rcpt[1] = '#') or (Rcpt[1] = '&') then
 begin
   Delete(Rcpt, 1, 1);
   ChannelMode(Socket, Rcpt, Flags, Nick);
 end else UserMode(Socket, Rcpt, Flags, Nick);
end;
procedure TMainForm.ChannelMode(Socket: Integer; Rcpt, Flags, Nick: String);
var OnCh, Oper: boolean;
    Mode, Args, SetMode, DelMode, Arg: String;
    ChInfo: TChannelInfo;
    Key, Lim: boolean;
    Add: byte;
Const ModeChar = ['o', 'p', 's', 'i', 't', 'n', 'm', 'l', 'b', 'v', 'k'];
begin
  OnCh := DataStore.IsOn(Nick, Rcpt);
  Oper := DataStore.ChanUsersOper.AsBoolean;
  If CharInString(' ', Flags) > 0 then
  begin
    Mode := Copy(Flags, 1, Pos(' ', Flags)-1);
    Delete(Flags, 1, Length(Mode)+1);
    Args := Flags;
    Flags := '';
  end else begin Mode := Flags; Flags := ''; Args := '' end;
  SetMode := '';
  ChInfo := DataStore.GetChannelInfo(Rcpt);
  If (ChInfo.ID = 0) then
  begin
    WriteCl(Socket, Format('%d %s '+MSG_NOSUCHCHANNEL, [ERR_NOSUCHCHANNEL, Nick, '#'+Rcpt]));
    Exit;
  end;
  If Length(Mode) = 0 then
  begin
    If CharInString('k', ChInfo.Flags) > 0 then
      SetMode := SetMode + ChInfo.KEY;
    If CharInString('l', ChInfo.Flags) > 0 then
    begin
      If SetMode <> '' then SetMode := SetMode + ' ';
      SetMode := SetMode + itoa(ChInfo.Limit);
    end;
    If not OnCh then WriteCl(Socket, Format('%d %s '+MSG_CHANNELMODEIS, [RPL_CHANNELMODEIS, Nick, '#'+Rcpt, '+'+ChInfo.FLAGS, '']))
    else WriteCl(Socket, Format('%d %s '+MSG_CHANNELMODEIS, [RPL_CHANNELMODEIS, Nick, '#'+Rcpt, '+'+ChInfo.FLAGS, SetMode]));
    WriteCl(Socket, Format('%d %s '+MSG_CHANNELCREATE, [RPL_CHANNELCREATE, Nick, '#'+Rcpt, ChInfo.CTime]));
    Exit;
  end;
  SetMode := '';
  DelMode := '';
  Key := false; Lim := false; Add := 2;
  while Length(Mode) > 0 do
  begin
     If Mode[1] = '+' then Add := 1;
     If Mode[1] = '-' then Add := 0;
     If (Mode[1] = '+') or (Mode[1] = '-') then Delete(Mode, 1, 1);

    If not (Mode[1] in ModeChar) then
       WriteCl(Socket, Format('%d %s '+MSG_UNKNOWNMODE, [ERR_UNKNOWNMODE, Nick, Mode[1]]))
    else
    begin
     If (Add <> 2) then
     begin
        If Mode[1] = 'b' then MakeChBan(Socket, Nick, Rcpt, GetArg(Args), Add = 1, OnCh, Oper);
        If Mode[1] = 'o' then MakeChOper(Socket, Nick, Rcpt, GetArg(Args), Add = 1, OnCh, Oper);
        If Mode[1] = 'v' then MakeChVoice(Socket, Nick, Rcpt, GetArg(Args), Add = 1, OnCh, Oper);
      If (Mode[1] in ['p', 's', 'i', 't', 'n', 'm', 'k', 'l']) then
      begin
        If not OnCh then
          WriteCl(Socket, Format('%d %s '+MSG_NOTONCHANNEL, [ERR_NOTONCHANNEL, Nick, '#'+Rcpt]))
       else If not Oper then
          WriteCl(Socket, Format('%d %s '+MSG_CHANOPRIVSNEEDED, [ERR_CHANOPRIVSNEEDED, Nick, '#'+Rcpt]))
       else
         If (CharInString(Mode[1], ChInfo.Flags) = 0) then
         begin
           If Add = 1 then begin
             If (Mode[1] = 'k') then
             begin
                Arg := GetArg(Args);
                If Arg <> '' then
                begin
                  ChInfo.Key := Arg;
                  ChInfo.Flags := ChInfo.Flags + Mode[1];
                  SetMode := SetMode + Mode[1];
                  Key := true;
                end;
             end else
               If (Mode[1] = 'l') then
               begin
                  Arg := GetArg(Args);
                  If itoa(atoi(Arg)) = Arg then 
                   begin
                      ChInfo.Limit := StrToInt(Arg);
                      ChInfo.Flags := ChInfo.Flags + Mode[1];
                      SetMode := SetMode + Mode[1];
                      Lim := true;
                   end;
               end else
                begin
                 ChInfo.Flags := ChInfo.Flags + Mode[1];
                 SetMode := SetMode + Mode[1];
                end;
           end;
         end else
         begin
           If Add = 0 then begin
             If Mode[1] = 'k' then ChInfo.Key := '';
             If Mode[1] = 'l' then ChInfo.Limit := 0;
             Delete(ChInfo.Flags, pos(Mode[1], ChInfo.Flags), 1);
             DelMode := DelMode + Mode[1];
           end;
         end;
      end;
    end;
    end;
    Delete(Mode, 1, 1);
  end;
  If (SetMode <> '') or (DelMode <> '') then
  begin
    If SetMode <> '' then SetMode := '+'+SortChars(SetMode);
    If DelMode <> '' then SetMode := SetMode + '-'+SortChars(DelMode);
    If Key then SetMode := SetMode +' '+ ChInfo.Key;
    If Lim then SetMode := SetMode +' '+ itoa(ChInfo.Limit);
    WriteChan(0, Rcpt, Format(':%s MODE %s %s', [DataStore.UserBySocket(Socket), '#'+Rcpt, SetMode]));
    DataStore.SetChannelInfo(Rcpt, ChInfo);
  end;
{  o - give/take channel operator privileges;
   p - private channel flag;
   s - secret channel flag;
   i - invite-only channel flag;
   t - topic settable by channel operator only flag;
   n - no messages to channel from clients on the outside;
   m - moderated channel;
   l - set the user limit to channel;
   b - set a ban mask to keep users out;
   v - give/take the ability to speak on a moderated channel;
   k - set a channel key (password).
}
end;
procedure TMainForm.MakeChBan(Socket: Integer; Nick, Rcpt, Arg: String; Add, OnCh, Oper: Boolean);
var BList: TStringList;
    res: boolean;
begin
  If Arg = '' then
  begin
    Blist := DataStore.GetBanList(Rcpt);
    While BList.Count > 0 do
    begin
      WriteCl(Socket, Format('%d %s '+MSG_BANLIST, [RPL_BANLIST, Nick, '#'+Rcpt, BList.Strings[0]]));
      BList.Delete(0);
    end;
    WriteCl(Socket, Format('%d %s '+MSG_ENDOFBANLIST, [RPL_ENDOFBANLIST, Nick, '#'+Rcpt]));
    BList.Free;
  end else
  begin
    If not OnCh then
    begin
      WriteCl(Socket, Format('%d %s '+MSG_NOTONCHANNEL, [ERR_NOTONCHANNEL, Nick, '#'+Rcpt]));
      Exit;
    end;
    If not Oper then
    begin
      WriteCl(Socket, Format('%d %s '+MSG_CHANOPRIVSNEEDED, [ERR_CHANOPRIVSNEEDED, Nick, '#'+Rcpt]));
      Exit;
    end;
    If Add then res := DataStore.AddToBan(Rcpt, Arg, Nick, GetIrcTime) else
       res := DataStore.DelBan(Rcpt, Arg);
    If Res then
    begin
      If Add then WriteChan(0, Rcpt, Format(':%s MODE %s %s %s', [DataStore.UserBySocket(Socket), '#'+Rcpt, '+b', Arg])) else
         WriteChan(0, Rcpt, Format(':%s MODE %s %s %s', [DataStore.UserBySocket(Socket), '#'+Rcpt, '-b', Arg]));
    end;
  end;
end;
procedure TMainForm.MakeChOper(Socket: Integer; Nick, Rcpt, Arg: String; Add, OnCh, Oper: Boolean);
var Res: byte;
begin
  If Arg <> '' then
  begin
    If not OnCh then
    begin
      WriteCl(Socket, Format('%d %s '+MSG_NOTONCHANNEL, [ERR_NOTONCHANNEL, Nick, '#'+Rcpt]));
      Exit;
    end;
    If not Oper then
    begin
      WriteCl(Socket, Format('%d %s '+MSG_CHANOPRIVSNEEDED, [ERR_CHANOPRIVSNEEDED, Nick, '#'+Rcpt]));
      Exit;
    end;
    Res := DataStore.MakeOper(Rcpt, Arg, Add);
    If (Res = 1) then
    begin
      If Add then WriteChan(0, Rcpt, Format(':%s MODE %s %s %s', [DataStore.UserBySocket(Socket), '#'+Rcpt, '+o', Arg])) else
         WriteChan(0, Rcpt, Format(':%s MODE %s %s %s', [DataStore.UserBySocket(Socket), '#'+Rcpt, '-o', Arg]));
    end;
  end;
end;
procedure TMainForm.MakeChVoice(Socket: Integer; Nick, Rcpt, Arg: String; Add, OnCh, Oper: Boolean);
var Res: byte;
begin
  If Arg <> '' then
  begin
    If not OnCh then
    begin
      WriteCl(Socket, Format('%d %s '+MSG_NOTONCHANNEL, [ERR_NOTONCHANNEL, Nick, '#'+Rcpt]));
      Exit;
    end;
    If not Oper then
    begin
      WriteCl(Socket, Format('%d %s '+MSG_CHANOPRIVSNEEDED, [ERR_CHANOPRIVSNEEDED, Nick, '#'+Rcpt]));
      Exit;
    end;
    Res := DataStore.MakeVoice(Rcpt, Arg, Add);
    If (Res = 1) then
    begin
      If Add then WriteChan(0, Rcpt, Format(':%s MODE %s %s %s', [DataStore.UserBySocket(Socket), '#'+Rcpt, '+v', Arg])) else
         WriteChan(0, Rcpt, Format(':%s MODE %s %s %s', [DataStore.UserBySocket(Socket), '#'+Rcpt, '-v', Arg]));
    end;
  end;
end;
procedure TMainForm.UserMode(Socket: Integer; Rcpt, Flags, Nick: String);
var UInfo, RInfo: TUserInfo;
    Op: Boolean;
    SetMode, DelMode: String;
    Add: byte;
const dopusk = ['i', 's', 'w', 'o', 'O', 'D', 'R', 'h'];
begin
  UInfo := DataStore.GetUserInfo(Socket);
  RInfo := DataStore.GetUserInfo(Rcpt);
  Op := UInfo.OPER;
  SetMode := '';
  If (LowerCase(Nick) <> LowerCase(Rcpt)) and (not Op) then
  begin
    WriteCl(Socket, Format('%d %s '+MSG_USERSDONTMATCH, [ERR_USERSDONTMATCH, Nick]));
    Exit;
  end;
  If (RInfo.Id = 0) then
  begin
    WriteCl(Socket, Format('%d %s '+MSG_NOSUCHNICK, [ERR_NOSUCHNICK, Nick, Rcpt]));
    Exit;
  end;
  If Flags = '' then
  begin
    If RInfo.OPER then SetMode := 'o';
    If RInfo.INVISIBLE then SetMode := SetMode + 'i';
    If RInfo.WALLOP then SetMode := SetMode + 'w';
    WriteCl(Socket, Format('%d %s %s %s', [RPL_UMODEIS, Nick, Rcpt, SetMode+RInfo.EXTMODE]));
    Exit;
  end;
  Add := 2;
  SetMode := ''; DelMode := '';
  while Length(Flags) > 0 do
  begin
    If Flags[1] = '+' then Add := 1;
    If Flags[1] = '-' then Add := 0;
    if not (Flags[1] in ['+', '-']) then
      if (Flags[1] in dopusk) then
      begin
        if (Flags[1] = 'o') and (Add = 1) then
        begin
          if CharInString('s', RInfo.ExtMode) = 0 then
          begin
            SetMode := SetMode + 's';
            RInfo.ExtMode := RInfo.ExtMode + 's';
          end;
        end;
        if (Flags[1] = 'h') and (Add = 1) and (Op) then
          if CharInString('h', RInfo.ExtMode) = 0 then
          begin
            SetMode := SetMode + 'h';
            RInfo.ExtMode := RInfo.ExtMode + Flags[1];
          end;
        if (Flags[1] = 's') and (CharInString('s', RInfo.ExtMode) = 0) then
        begin
           SetMode := SetMode + Flags[1];
           RInfo.EXTMODE := RInfo.EXTMODE + Flags[1];
        end;                                    
        if (Flags[1] = 'w') and (Add = 1) and (not RInfo.Wallop) then
        begin
           SetMode := SetMode + Flags[1];
           RInfo.Wallop := true;
        end;
        if (Flags[1] = 'i') and (Add = 1) and (not RInfo.Invisible) then
        begin
           SetMode := SetMode + Flags[1];
           RInfo.INVISIBLE := true;
        end;
        if (Add = 0) then
        begin
          if (Flags[1] = 'i') and (RInfo.Invisible) then
          begin
             DelMode := DelMode + Flags[1];
             RInfo.INVISIBLE := false;
          end;
          if (Flags[1] in ['s', 'D', 'R', 'O', 'h']) and (CharInString(Flags[1], RInfo.ExtMode) > 0) then
          begin
             DelMode := DelMode + Flags[1];
             Delete(RInfo.EXTMODE, pos(Flags[1], RInfo.EXTMODE), 1);
          end;
          if (Flags[1] = 'w') and (RInfo.Wallop) then
          begin
             DelMode := DelMode + Flags[1];
             RInfo.Wallop := false;
          end;
          if (Flags[1] = 'o') and (RInfo.Oper) then
          begin
             DelMode := DelMode + Flags[1];
             RInfo.Oper := false;
             Flags := Flags+'-wODRh';
          end;
        end;
      end else WriteCl(Socket, Format('%d %s '+MSG_UMODEUNKNOWNFLAG, [ERR_UMODEUNKNOWNFLAG, Nick, Flags[1]]));
    Delete(Flags, 1, 1);
  end;
  If (SetMode <> '') or (DelMode <> '') then
  begin
    DataStore.SetUserInfo(RInfo.Nick, RInfo);
    if SetMode <> '' then
    begin
      SetMode := '+'+SetMode;
      WriteCl(Socket, Format(':%s!%s@%s MODE %s :%s', [Nick, UInfo.UserId, UInfo.Hostname, Rcpt, SetMode]), false);
      if (UInfo.Socket <> RInfo.Socket) then
         WriteCl(RInfo.Socket, Format(':%s!%s@%s MODE %s :%s', [Nick, UInfo.UserId, UInfo.Hostname, Rcpt, SetMode]), false);
    end;
    if DelMode <> '' then
    begin
      DelMode := '-'+DelMode;
      WriteCl(Socket, Format(':%s!%s@%s MODE %s :%s', [Nick, UInfo.UserId, UInfo.Hostname, Rcpt, DelMode]), false);
      if (UInfo.Socket <> RInfo.Socket) then
         WriteCl(RInfo.Socket, Format(':%s!%s@%s MODE %s :%s', [Nick, UInfo.UserId, UInfo.Hostname, Rcpt, DelMode]), false);
    end;
  end;
{   i - marks a users as invisible;
    s - marks a user for receipt of server notices;
    w - user receives wallops;
    o - operator flag;
    R - restart privs
    D - die privs
}
end;
procedure TMainForm.MakePart(Socket: Integer; Arg: String);
var Nick, Chan: String;
begin
{ERR_NOTONCHANNEL}
  Nick := DataStore.NickBySocket(Socket);
  If Arg = '' then
  begin
    WriteCl(Socket, Format('%d %s '+MSG_NEEDMOREPARAMS, [ERR_NEEDMOREPARAMS, Nick, 'PART']));
    Exit;
  end;
  while Length(Arg) > 0 do
  begin
    If CharInString(',', Arg) > 0 then
    begin
       Chan := Copy(Arg, 1, Pos(',', Arg)-1);
       Delete(Arg, 1, Length(Chan)+1);
    end else begin Chan := Arg; Arg := ''; end;
    If (Length(Chan) > 0) and ((Chan[1] = '#') or (Chan[1]='&')) then
    begin
      Delete(Chan, 1, 1);
      If (DataStore.FindChannelId(Chan) = 0) then
        WriteCl(Socket, Format('%d %s '+MSG_NOSUCHCHANNEL, [ERR_NOSUCHCHANNEL, Nick, '#'+Chan]))
       else begin
         If DataStore.DelFromChan(Nick, Chan) then
            WriteChan(Socket, Chan, Format(':%s PART %s', [DataStore.UserBySocket(Socket), '#'+Chan]))
         else WriteCl(Socket, Format('%d %s '+MSG_NOTONCHANNEL, [ERR_NOTONCHANNEL, Nick, '#'+Chan]));
       end;
    end;
  end;
end;
procedure TMainForm.MakeQuit(Socket: Integer; Arg: String);
begin
  WriteAll(Format(':%s QUIT %s', [DataStore.UserBySocket(Socket), Arg]));
  DataStore.DelUser(Socket);
  GetSocketByHandle(Socket).Destroy;
end;
procedure TMainForm.MakeList(Socket: Integer; Arg: String);
var Nick, Chans, Server, Chan: String;
    List: TStringList;
begin
{ERR_NOSUCHSERVER}
  List := TStringList.Create;
  Nick := DataStore.NickBySocket(Socket);
  If CharInString(' ', Arg) > 0 then
  begin
    Chans := Copy(Arg, 1, Pos(' ', Arg)-1);
    Delete(Arg, 1, Length(Chans)+1);
    Server := Arg;
  end else begin Server := ''; Chans := Arg; Arg := ''; end;
  WriteCl(Socket, Format('%d %s '+MSG_LISTSTART, [RPL_LISTSTART, Nick]));
  If Length(Chans) = 0 then List.Text := DataStore.GetList(Nick, '').Text;
  while Length(Chans) > 0 do
  begin
    If CharInString(',', Chans) > 0 then
    begin
      Chan := Copy(Chans, 1, Pos(',', Chans)-1);
      Delete(Chans, 1, Length(Chan)+1);
    end else begin Chan := Chans; Chans := ''; end;
    If (Length(Chan) > 0) and (Chan[1] in ['#', '&']) then
      Delete(Chan, 1, 1);
    List.Text := List.Text + DataStore.GetList(Nick, Chan).Text;
  end;
  while List.Count > 0 do
  begin
    WriteCl(Socket, Format('%d %s '+MSG_LIST, [RPL_LIST, Nick, List.Strings[0]]));
    List.Delete(0);
  end;
  WriteCl(Socket, Format('%d %s '+MSG_LISTEND, [RPL_LISTEND, Nick]));
  List.Free;
end;
procedure TMainForm.MakeInvite(Socket: Integer; Arg: String);
var Who, Chan, Nick, User: String;
    OnCh, Oper: boolean;
    I: Integer;
    UInfo, RInfo: TUserInfo;
begin
 UInfo := DataStore.GetUserInfo(Socket);
 If UInfo.ID <> 0 then
 begin
   Nick := UInfo.NICK;
   User := Format('%s!%s@%s', [UInfo.Nick, UInfo.UserId, UInfo.Hostname]);
 end;  
 If CharInString(' ', Arg) > 0 then
 begin
   Who := Copy(Arg, 1, Pos(' ', Arg)-1);
   Delete(Arg, 1, Length(Who)+1);
   Chan := Arg;
 end else begin Who := ''; Chan := ''; end;
 If (Who = '') then
 begin
   WriteCl(Socket, Format('%d %s '+MSG_NEEDMOREPARAMS, [ERR_NEEDMOREPARAMS, Nick, 'INVITE']));
   Exit;
 end;
 If (Length(Chan) > 0) and (Chan[1] in ['#', '&']) then
  Delete(Chan, 1, 1) else Chan := '';
 I := DataStore.FindChannelId(Chan);
 If I = 0 then
 begin
   WriteCl(Socket, Format('%d %s '+MSG_NOSUCHCHANNEL, [ERR_NOSUCHCHANNEL, Nick, '#'+Chan]));
   Exit;
 end;
 OnCh := DataStore.IsOn(Nick, Chan);
 Oper := DataStore.ChanUsersOper.AsBoolean;
 If not OnCh then
 begin
   WriteCl(Socket, Format('%d %s '+MSG_NOTONCHANNEL, [ERR_NOTONCHANNEL, Nick, '#'+Chan]));
   Exit;
 end;
 If not Oper then
 begin
   WriteCl(Socket, Format('%d %s '+MSG_CHANOPRIVSNEEDED, [ERR_CHANOPRIVSNEEDED, Nick, '#'+Chan]));
   Exit;
 end;
 RInfo := DataStore.GetUserInfo(Who);
 If RInfo.ID = 0 then
 begin
   WriteCl(Socket, Format('%d %s '+MSG_NOSUCHNICK, [ERR_NOSUCHNICK, Nick, Who]));
   Exit;
 end;
 If RInfo.Away <> '' then
 begin
   WriteCl(Socket, Format('%d %s '+MSG_AWAY, [RPL_AWAY, Nick, RInfo.Nick, RInfo.Away]));
   Exit;
 end;
 DataStore.AddToInvite(I, Who);
 WriteCl(DataStore.SocketByNick(Who), Format(':%s INVITE %s :%s', [User, Who, '#'+Chan]), false);
 WriteCl(Socket, Format('%d %s '+MSG_INVITING, [RPL_INVITING, Nick, '#'+Chan,Who]));
end;
procedure TMainForm.MakeKick(Socket: Integer; Arg: String);
var Who, Chan, Nick, User, Reason: String;
    OnCh, Oper: boolean;
    I: Integer;
    UInfo: TUserInfo;
begin
 UInfo := DataStore.GetUserInfo(Socket);
 If UInfo.ID <> 0 then
 begin
   Nick := UInfo.NICK;
   User := Format('%s!%s@%s', [UInfo.Nick, UInfo.UserId, UInfo.Hostname]);
 end;
 If CharInString(' ', Arg) > 0 then
 begin
   Chan := Copy(Arg, 1, Pos(' ', Arg)-1);
   Delete(Arg, 1, Length(Chan)+1);
   Who := Arg;
   If CharInString(' ', Arg) > 0 then
   begin
     Who := Copy(Arg, 1, Pos(' ', Arg)-1);
     Delete(Arg, 1, Length(Who)+1);
     Reason := Arg;
   end;
   Arg := '';
 end else begin Who := ''; Chan := ''; end;
 If (Who = '') then
 begin
   WriteCl(Socket, Format('%d %s '+MSG_NEEDMOREPARAMS, [ERR_NEEDMOREPARAMS, Nick, 'INVITE']));
   Exit;
 end;
 If (Length(Chan) > 0) and (Chan[1] in ['#', '&']) then
  Delete(Chan, 1, 1) else Chan := '';
 If (Chan = '') then
 begin
   WriteCl(Socket, Format('%d %s :Bad channel mask', [ERR_BADCHANMASK, Nick]));
   Exit;
 end;
 I := DataStore.FindChannelId(Chan);
 If I = 0 then
 begin
   WriteCl(Socket, Format('%d %s '+MSG_NOSUCHCHANNEL, [ERR_NOSUCHCHANNEL, Nick, '#'+Chan]));
   Exit;
 end;
 OnCh := DataStore.IsOn(Nick, Chan);
 Oper := DataStore.ChanUsersOper.AsBoolean;
 If not OnCh then
 begin
   WriteCl(Socket, Format('%d %s '+MSG_NOTONCHANNEL, [ERR_NOTONCHANNEL, Nick, '#'+Chan]));
   Exit;
 end;
 If not Oper then
 begin
   WriteCl(Socket, Format('%d %s '+MSG_CHANOPRIVSNEEDED, [ERR_CHANOPRIVSNEEDED, Nick, '#'+Chan]));
   Exit;
 end;
//Kick make
 If DataStore.FindUserId(Who) = 0 then
 begin
   WriteCl(Socket, Format('%d %s '+MSG_NOSUCHNICK, [ERR_NOSUCHNICK, Nick, Who]));
   Exit;
 end;
 If (Reason = '') then Reason := ':'+Nick;
 WriteChan(0, Chan, Format(':%s KICK %s %s %s', [User, '#'+Chan, Who, Reason]));
 DataStore.DelFromChan(Who, I);
end;
procedure TMainForm.MakeLusers(Socket: Integer; Arg: String);
var Nick: String;
    Users, Invis, Servs, Ops, Chans, Global: Integer;
begin
  Nick := DataStore.NickBySocket(Socket);
  Global := DataStore.UserCount(Invis, Ops, Users);
  Chans := DataStore.GetChansCount;
  Servs := 1;
  WriteCl(Socket, Format('%d %s '+MSG_LUSERCLIENT, [RPL_LUSERCLIENT, Nick, Users, Invis, Servs]));
  If (Ops <> 0) then WriteCl(Socket, Format('%d %s '+MSG_LUSEROP, [RPL_LUSEROP, Nick, Ops]));
  If (0 <> 0) then WriteCl(Socket, Format('%d %s '+MSG_LUSERUNKNOWN, [RPL_LUSERUNKNOWN, Nick, 0]));
  If (Chans <> 0) then WriteCl(Socket, Format('%d %s '+MSG_LUSERCHANNELS, [RPL_LUSERCHANNELS, Nick, Chans]));
  WriteCl(Socket, Format('%d %s '+MSG_LUSERME, [RPL_LUSERME, Nick, Global, 0]));
end;
procedure TMainForm.MakeWho(Socket: Integer; Arg: String);
var Nick, Who, temp, tmp: String;
    Ops: boolean;
    List: TStringList;
begin
  Nick := DataStore.NickbySocket(Socket);
  If CharInString(' ', Arg) > 0 then
  begin
    Who := Copy(Arg, 1, Pos(' ', Arg)-1);
    Delete(Arg, 1, Length(Who)+1);
    If (Length(Arg) > 0) and (LowerCase(Arg[1]) = 'o') then Ops := true
     else Ops := false;
  end else begin Who := Arg; Ops := false; end;
  List := DataStore.GetWhoList(Nick, Who, ops);
  while List.Count > 0 do
  begin
    tmp := List.Strings[0];
    temp := Copy(tmp, 1, pos(' ', tmp)-1);
    Delete(tmp, 1, Length(temp)+1);
    WriteCl(Socket, Format('%d %s %s', [RPL_WHOREPLY, Nick, tmp]));
    List.Delete(0)
  end;
  WriteCl(Socket, Format('%d %s '+MSG_ENDOFWHO, [RPL_ENDOFWHO, Nick, Who]));
  List.Free;
end;
procedure TMainForm.OperTabShow(Sender: TObject);
var Item: TListItem;
begin
  OperList.Items.Clear;
  DataStore.Opers.First;
  If DataStore.Opers.Eof then
  begin
    EditProperties1.Visible := false;
    DelOperator1.Visible := false;
  end else
  begin
     EditProperties1.Visible := true;
     DelOperator1.Visible := true;
  end;
  while not DataStore.Opers.Eof do
  begin
    Item := OperList.Items.Add;
    Item.Caption := DataStore.OpersNick.AsString;
    Item.SubItems.Add(DataStore.OpersPASSWORD.AsString);
    Item.SubItems.Add(DataStore.OpersHOSTMASK.AsString);
    Item.SubItems.Add(DataStore.OpersMODE.AsString);
    DataStore.Opers.Next;
    Item.ImageIndex := 0;
  end;
end;

procedure TMainForm.EditProperties1Click(Sender: TObject);
var Item: TListItem;
    OInfo: TOperInfo;
begin
  Item := OperList.Selected;
  If Assigned(Item) then
  begin
     OInfo := DataStore.GetOper(Item.Caption);
   If (OInfo.Name <> '') then
   begin
     OperForm.Edit1.Text := OInfo.NAME;
     OperForm.Edit2.Text := OInfo.PASS;
     OperForm.Edit3.Text := OInfo.HOSTMASK;
     OperForm.Globop.Checked := (CharInString('O', OInfo.Flags) > 0);
     OperForm.Restop.Checked := (CharInString('R', OInfo.Flags) > 0);
     OperForm.Dieop.Checked  := (CharInString('D', OInfo.Flags) > 0);
     OperForm.Edit1.Enabled  := false;
     OperForm.Caption := 'Edit Properties For Operator '+OInfo.NAME;
     OperForm.ShowModal;
     If (OperForm.ModalResult = mrOk) then
     begin
       OInfo.PASS := OperForm.Edit2.Text;
       OInfo.HOSTMASK := OperForm.Edit3.Text;
       if OperForm.Globop.Checked and (CharInString('O', OInfo.Flags) = 0) then OInfo.Flags := OInfo.Flags + 'O';
       if OperForm.Restop.Checked and (CharInString('R', OInfo.Flags) = 0) then OInfo.Flags := OInfo.Flags + 'R';
       if OperForm.Dieop.Checked  and (CharInString('D', OInfo.Flags) = 0) then OInfo.Flags := OInfo.Flags + 'D';
       if (not OperForm.Globop.Checked) and (CharInString('O', OInfo.Flags) > 0) then Delete(OInfo.Flags, Pos('O', OInfo.Flags), 1);
       if (not OperForm.Restop.Checked) and (CharInString('R', OInfo.Flags) > 0) then Delete(OInfo.Flags, Pos('R', OInfo.Flags), 1);
       if (not OperForm.Dieop.Checked)  and (CharInString('D', OInfo.Flags) > 0) then Delete(OInfo.Flags, Pos('D', OInfo.Flags), 1);
       DataStore.SetOper(Item.Caption, OInfo);
       Item.SubItems.Clear;
       Item.SubItems.Add(OInfo.Pass);
       Item.SubItems.Add(OInfo.HostMask);
       Item.SubItems.Add(OInfo.Flags);
     end;
   end;
  end;
end;

procedure TMainForm.AddOper1Click(Sender: TObject);
var OInfo: TOperInfo;
begin
  OperForm.Edit1.Text := '';
  OperForm.Edit1.Enabled := true;
  OperForm.Edit2.Text := '';
  OperForm.Edit3.Text := '';
  OperForm.Globop.Checked := false;
  OperForm.Restop.Checked := false;
  OperForm.Dieop.Checked := false;
  OperForm.Caption := 'Add Server Operator';
  OperForm.ShowModal;
  If (OperForm.ModalResult = mrOk) then
  begin
    OInfo.NAME := OperForm.Edit1.Text;
    OInfo.PASS := OperForm.Edit2.Text;
    OInfo.HOSTMASK := OperForm.Edit3.Text;
    OInfo.Flags := '';
    if OperForm.Globop.Checked then OInfo.Flags := OInfo.Flags + 'O';
    if OperForm.Restop.Checked then OInfo.Flags := OInfo.Flags + 'R';
    if OperForm.Dieop.Checked  then OInfo.Flags := OInfo.Flags + 'D';
    DataStore.AddOper(OInfo);
    with OperList.Items.Add do
    begin
      ImageIndex := 0;
      Caption := OInfo.NAME;
      SubItems.Add(OInfo.PASS);
      SubItems.Add(OInfo.HOSTMASK);
      SubItems.Add(OInfo.FLAGS);
    end;
  end;
  EditProperties1.Visible := true;
  DelOperator1.Visible := true;
end;

procedure TMainForm.DelOperator1Click(Sender: TObject);
var Item: TListItem;
begin
  Item := OperList.Selected;
  If Assigned(Item) then
  begin
    DataStore.DelOper(Item.Caption);
    Item.Delete;
  end;
  If OperList.Items.Count = 0 then
  begin
    EditProperties1.Visible := false;
    DelOperator1.Visible := false;
  end;
end;

procedure TMainForm.OperListDblClick(Sender: TObject);
begin
  If EditProperties1.Visible then EditProperties1Click(Sender);
end;
procedure TMainForm.MakeOper(Socket: Integer; Arg: String);
var Nick, Host, UserId, Name, Pass, Flags: String;
    UInfo: TUserInfo;
    i: integer;
    r: byte;
begin
  UInfo := DataStore.GetUserinfo(Socket);
  Nick := UInfo.Nick;
  UserId := UInfo.UserId;
  Host := UInfo.Hostname;
  Name := ''; Pass := ''; Flags := '';
  If (CharInString(' ', Arg) > 0) then
  begin
    Name := Copy(Arg, 1, Pos(' ', Arg)-1);
    Delete(Arg, 1, Length(Name)+1);
    Pass := Arg;
  end;
  If (Name = '') or (Pass = '') then
  begin
    WriteCl(Socket, Format('%d %s '+MSG_NEEDMOREPARAMS, [ERR_NEEDMOREPARAMS, Nick, 'OPER']));
    Exit;
  end;
  r := DataStore.BecomeOper(Nick, UserId, Host, Name, Pass, Flags);
  if (r = 3) then r := DataStore.BecomeOper(Nick, UserId, GetSocketByHandle(Socket).RemoteAddress, Name, Pass, Flags);
  case r of
    0, 3: WriteCl(Socket, Format('%d %s '+MSG_NOOPERHOST, [ERR_NOOPERHOST, Nick]));
    2: WriteCl(Socket, Format('%d %s '+MSG_PASSWDMISMATCH, [ERR_PASSWDMISMATCH, Nick]));
    1: begin
      UInfo.OPER := true;
      UInfo.WALLOP := true;
      Flags := 's'+Flags;
      i := 1;
      while i <= Length(Flags) do
        If CharInString(Flags[i], UInfo.EXTMODE) = 0 then
        begin
          UInfo.ExtMode := UInfo.Extmode + Flags[i];
          inc(i);
        end else Delete(Flags, i, 1);
      DataStore.SetUserInfo(Socket, UInfo);
      WriteCl(Socket, Format(':%s!%s@%s MODE %s :+ow%s', ['OperServ', ServerName, pircds.Socket.LocalHost, Nick, Flags]), false);
      WriteCl(Socket, Format('%d %s '+MSG_YOUREOPER, [RPL_YOUREOPER, Nick]));
    end;
  end;
end;
procedure TMainForm.PingTimerTimer(Sender: TObject);
var I: Integer;
    delta: Cardinal;
begin
  for i := 0 to pircds.Socket.ActiveConnections - 1 do
  begin
    Delta := abs(DataStore.GetTime(pircds.Socket.Connections[i].SocketHandle)-GetIrcTime);
    If (Delta >= 90) then MakeQuit(pircds.Socket.Connections[i].SocketHandle, ':Ping Timeout')
    else If ((Delta >= 30) and (Delta <= 60)) then pircds.Socket.Connections[i].SendText('PING :'+ServerName+#$D#$A);
  end;
  do_refresh_list; //31.03.00
end;
procedure TMainForm.MakeTime(Socket: Integer; Arg: String);
var Nick: String;
begin
  Nick := DataStore.NickBySocket(Socket);
  WriteCl(Socket, Format('%d %s '+MSG_TIME, [RPL_TIME, Nick, ServerName, DateToStr(Date)+' '+TimeToStr(Time)]));
end;
procedure TMainForm.MakeKill(Socket: Integer; Arg: String);
var UInfo, RInfo: TUserInfo;
    Who, Reason: String;
    Nick, User: String;
begin
  UInfo := DataStore.GetUserInfo(Socket);
  If UInfo.ID <> 0 then
  begin
    Nick := UInfo.NICK;
    User := Format('%s!%s@%s', [UInfo.Nick, UInfo.UserId, UInfo.Hostname]);
  end;
  If CharInString(' ', Arg) > 0 then
  begin
    Who := Copy(Arg, 1, Pos(' ', Arg)-1);
    Delete(Arg, 1, Length(Who)+1);
    Reason := Arg;
    Arg := '';
  end else begin Who := Arg; Reason := ''; end;
  If (Who = '') then
  begin
    WriteCl(Socket, Format('%d %s '+MSG_NEEDMOREPARAMS, [ERR_NEEDMOREPARAMS, Nick, 'KILL']));
    Exit;
  end;
  If (not UInfo.Oper) then
  begin
    WriteCl(Socket, Format('%d %s '+MSG_NOPRIVILEGES, [ERR_NOPRIVILEGES, Nick]));
    Exit;
  end;
  RInfo := DataStore.GetUserInfo(Who);
  If (RInfo.Id = 0) then
  begin
    WriteCl(Socket, Format('%d %s '+MSG_NOSUCHNICK, [ERR_NOSUCHNICK, Nick, Who]));
    Exit;
  end;
  If (Reason = '') then Reason := ':'+Nick;
  WriteAll(Format(':%s KILL %s %s', [User, Who, Reason]));
  DataStore.DelUser(RInfo.Socket);
  GetSocketByHandle(RInfo.Socket).Destroy;
{ERR_CANTKILLSERVER}
end;
procedure TMainForm.MakeVersion(Socket: Integer; Arg: String);
begin
  WriteCl(Socket, Format('%d %s '+MSG_VERSION, [RPL_VERSION, DataStore.NickBySocket(Socket), '1.0', ServerName, 'Copyright (c) 1999 Wecrosoft Co. AHKLU']));
end;
procedure TMainForm.MakeSamode(Socket: Integer; Arg: String);
var Rcpt, Flags: String;
    UInfo: TUserInfo;
begin
 UInfo := DataStore.GetUserInfo(Socket);
 If (CharInString(' ', Arg) > 0) then
 begin
   Rcpt := Copy(Arg, 1, Pos(' ', Arg)-1);
   Delete(Arg, 1, Length(Rcpt)+1);
   Flags := Arg;
 end else begin Flags := ''; Rcpt := Arg; Arg := ''; end;
 If Length(Rcpt) = 0 then
 begin
   WriteCl(Socket, Format('%d %s '+MSG_NEEDMOREPARAMS, [ERR_NEEDMOREPARAMS, UInfo.Nick, 'SAMODE']));
   Exit;
 end;
 If (Rcpt[1] = '#') or (Rcpt[1] = '&') then
   Delete(Rcpt, 1, 1);
 ChannelSAMode(Socket, Rcpt, Flags, UInfo);
end;
procedure TMainForm.ChannelSAMode(Socket: Integer; Rcpt, Flags: String; UInfo: TUserInfo);
var Mode, Args, SetMode, DelMode, Arg: String;
    ChInfo: TChannelInfo;
    Key, Lim: boolean;
    Add: byte;
Const ModeChar = ['o', 'p', 's', 'i', 't', 'n', 'm', 'l', 'b', 'v', 'k'];
begin
 If not UInfo.Oper then
 begin
   WriteCl(Socket, Format('%d %s '+MSG_NOPRIVILEGES, [ERR_NOPRIVILEGES, UInfo.Nick]));
   Exit;
 end;
 WriteFlag(Format(':%s NOTICE %s :*** Global -- from %s %s used SAMODE (%s)', [ServerName, UInfo.Nick, ServerName, UInfo.Nick, '#'+Rcpt+' '+Flags]), 's'); 
  If CharInString(' ', Flags) > 0 then
  begin
    Mode := Copy(Flags, 1, Pos(' ', Flags)-1);
    Delete(Flags, 1, Length(Mode)+1);
    Args := Flags;
    Flags := '';
  end else begin Mode := Flags; Flags := ''; Args := '' end;
  SetMode := '';
  ChInfo := DataStore.GetChannelInfo(Rcpt);
  If (ChInfo.ID = 0) then
  begin
    WriteCl(Socket, Format('%d %s '+MSG_NOSUCHCHANNEL, [ERR_NOSUCHCHANNEL, UInfo.Nick, '#'+Rcpt]));
    Exit;
  end;
  If Length(Mode) = 0 then
  begin
    If CharInString('k', ChInfo.Flags) > 0 then
      SetMode := SetMode + ChInfo.KEY;
    If CharInString('l', ChInfo.Flags) > 0 then
    begin
      If SetMode <> '' then SetMode := SetMode + ' ';
      SetMode := SetMode + itoa(ChInfo.Limit);
    end;
    WriteCl(Socket, Format('%d %s '+MSG_CHANNELMODEIS, [RPL_CHANNELMODEIS, UInfo.Nick, '#'+Rcpt, '+'+ChInfo.FLAGS, SetMode]));
    WriteCl(Socket, Format('%d %s '+MSG_CHANNELCREATE, [RPL_CHANNELCREATE, UInfo.Nick, '#'+Rcpt, ChInfo.CTime]));
    Exit;
  end;
  SetMode := '';
  DelMode := '';
  Key := false; Lim := false; Add := 2;
  while Length(Mode) > 0 do
  begin
     If Mode[1] = '+' then Add := 1;
     If Mode[1] = '-' then Add := 0;
     If (Mode[1] = '+') or (Mode[1] = '-') then Delete(Mode, 1, 1);

    If not (Mode[1] in ModeChar) then
       WriteCl(Socket, Format('%d %s '+MSG_UNKNOWNMODE, [ERR_UNKNOWNMODE, UInfo.Nick, Mode[1]]))
    else
    begin
     If (Add <> 2) then
     begin
        If Mode[1] = 'b' then MakeChBan(Socket, UInfo.Nick, Rcpt, GetArg(Args), Add = 1, true, true);
        If Mode[1] = 'o' then MakeChOper(Socket, UInfo.Nick, Rcpt, GetArg(Args), Add = 1, true, true);
        If Mode[1] = 'v' then MakeChVoice(Socket, UInfo.Nick, Rcpt, GetArg(Args), Add = 1, true, true);
      If (Mode[1] in ['p', 's', 'i', 't', 'n', 'm', 'k', 'l']) then
      begin
         If (CharInString(Mode[1], ChInfo.Flags) = 0) then
         begin
           If Add = 1 then begin
             If (Mode[1] = 'k') then
             begin
                Arg := GetArg(Args);
                If Arg <> '' then
                begin
                  ChInfo.Key := Arg;
                  ChInfo.Flags := ChInfo.Flags + Mode[1];
                  SetMode := SetMode + Mode[1];
                  Key := true;
                end;
             end else
               If (Mode[1] = 'l') then
               begin
                  Arg := GetArg(Args);
                  If itoa(atoi(Arg)) = Arg then 
                   begin
                      ChInfo.Limit := StrToInt(Arg);
                      ChInfo.Flags := ChInfo.Flags + Mode[1];
                      SetMode := SetMode + Mode[1];
                      Lim := true;
                   end;
               end else
                begin
                 ChInfo.Flags := ChInfo.Flags + Mode[1];
                 SetMode := SetMode + Mode[1];
                end;
           end;
         end else
         begin
           If Add = 0 then begin
             If Mode[1] = 'k' then ChInfo.Key := '';
             If Mode[1] = 'l' then ChInfo.Limit := 0;
             Delete(ChInfo.Flags, pos(Mode[1], ChInfo.Flags), 1);
             DelMode := DelMode + Mode[1];
           end;
         end;
      end;
    end;
    end;
    Delete(Mode, 1, 1);
  end;
  If (SetMode <> '') or (DelMode <> '') then
  begin
    If SetMode <> '' then SetMode := '+'+SortChars(SetMode);
    If DelMode <> '' then SetMode := SetMode + '-'+SortChars(DelMode);
    If Key then SetMode := SetMode +' '+ ChInfo.Key;
    If Lim then SetMode := SetMode +' '+ itoa(ChInfo.Limit);
    WriteChan(0, Rcpt, Format(':%s MODE %s %s', [UInfo.Nick+'!'+UInfo.UserId+'@'+UInfo.Hostname, '#'+Rcpt, SetMode]));
    DataStore.SetChannelInfo(Rcpt, ChInfo);
  end;
end;
procedure TMainForm.MakeWallops(Socket: Integer; Arg: String);
var UInfo: TUserInfo;
begin
  UInfo := DataStore.GetUserInfo(Socket);
  If (Arg = '') then
  begin
    WriteCl(Socket, Format('%d %s '+MSG_NEEDMOREPARAMS, [ERR_NEEDMOREPARAMS, UInfo.Nick, 'WALLOPS']));
    Exit;
  end;
  If (not UInfo.OPER) then
  begin
    WriteCl(Socket, Format('%d %s '+MSG_NOPRIVILEGES, [ERR_NOPRIVILEGES, UInfo.Nick]));
    Exit;
  end;
  WriteFlag(Format(':%s WALLOPS %s', [UInfo.Nick+'!'+Uinfo.UserId+'@'+UInfo.Hostname, Arg]), 'w');
end;
procedure TMainForm.MakeIsOn(Socket: Integer; Arg: String);
var Nick, Who, List: String;
begin
  Nick := DataStore.NickBySocket(Socket);
  If (Arg = '') then
  begin
    WriteCl(Socket, Format('%d %s '+MSG_NEEDMOREPARAMS, [ERR_NEEDMOREPARAMS, Nick, 'ISON']));
    Exit;
  end;
  List := '';
  while Length(Arg) > 0 do
  begin
    If CharInString(' ', Arg) > 0 then
    begin
      Who := Copy(Arg, 1, Pos(' ', Arg) - 1);
      Delete(Arg, 1, Length(Who)+1);
    end else begin Who := Arg; Arg := ''; end;
    If DataStore.IsOn(Who) then
    begin
      If (List <> '') then List := List + ' ';
      List := List + Who;
    end;
  end;
  WriteCl(Socket, Format('%d %s '+MSG_ISON, [RPL_ISON, Nick, List]));
end;
procedure TMainForm.MakeAway(Socket: Integer; Arg: String);
var UInfo: TUserInfo; 
begin
  UInfo := DataStore.GetUserInfo(Socket);
  If (Length(Arg) > 0) and (Arg[1] = ':') then Delete(Arg, 1, 1);
  If (Arg <> '') then
  begin
    UInfo.Away := Arg;
    WriteCl(Socket, Format('%d %s '+MSG_NOWAWAY, [RPL_NOWAWAY, UInfo.Nick]));
  end else
  begin
    UInfo.Away := '';
    WriteCl(Socket, Format('%d %s '+MSG_UNAWAY, [RPL_UNAWAY, UInfo.Nick]));
  end;
  DataStore.SetUserInfo(Socket, UInfo);
end;
procedure TMainForm.MakeWhois(Socket: Integer; Arg: String);
var UInfo: TUserInfo;
    Nick, Server, who, whos, channels: String;
begin
{ERR_NOSUCHSERVER}
 Nick := DataStore.NickBySocket(Socket);
 If Arg = '' then
 begin
   WriteCl(Socket, Format('%d %s '+MSG_NONICKNAMEGIVEN, [ERR_NONICKNAMEGIVEN, Nick]));
   Exit;
 end;
 If (CharInString(' ', Arg) > 0) then
 begin
    Server := Copy(Arg, 1, Pos(' ', Arg)-1);
    Delete(Arg, 1, Length(Server));
    who := Arg;
 end else begin who := Arg; Arg := ''; end;
 whos := who;
 while (Length(whos) > 0) do
 begin
   If CharInString(',', whos) > 0 then
   begin
     who := Copy(whos, 1, Pos(',', whos)-1);
     Delete(whos, 1, Length(who)+1);
   end else begin who := whos; whos := ''; end;
   UInfo := DataStore.GetUserInfo(who);
   if UInfo.Id <> 0 then
   begin
     Channels := DataStore.GetUChans(who);
     WriteCl(Socket, Format('%d %s '+MSG_WHOISUSER, [RPL_WHOISUSER, Nick, UInfo.Nick, UInfo.UserId, UInfo.Hostname, UInfo.RealName]));
     WriteCl(Socket, Format('%d %s '+MSG_WHOISCHANNELS, [RPL_WHOISCHANNELS, Nick, UInfo.Nick, Channels]));
     WriteCl(Socket, Format('%d %s '+MSG_WHOISSERVER, [RPL_WHOISSERVER, Nick, UInfo.Nick, UInfo.Hostname, 'No info']));
     If (UInfo.Away <> '')then WriteCl(Socket, Format('%d %s '+MSG_AWAY, [RPL_AWAY, Nick, UInfo.Nick, UInfo.Away]));
     If UInfo.Oper then WriteCl(Socket, Format('%d %s '+MSG_WHOISOPERATOR, [RPL_WHOISOPERATOR, Nick, UInfo.Nick]));
     WriteCl(Socket, Format('%d %s '+MSG_WHOISIDLE, [RPL_WHOISIDLE, Nick, UInfo.Nick, abs(UInfo.Time - GetIrcTime)]));
     WriteCl(Socket, Format('%d %s '+MSG_ENDOFWHOIS, [RPL_ENDOFWHOIS, Nick, UInfo.Nick]));
   end else WriteCl(Socket, Format('%s %d '+MSG_NOSUCHNICK, [ERR_NOSUCHNICK, Nick, who]));
 end;
end;
procedure TMainForm.MakeAdmin(Socket: Integer; Arg: String);
var Nick : String;
begin
  {ERR_NOSUCHSERVER}
  Nick := DataStore.NickBySocket(Socket);
  WriteCl(Socket, Format('%d %s '+MSG_ADMINME, [RPL_ADMINME, Nick, ServerName]));
  WriteCl(Socket, Format('%d %s '+MSG_ADMINLOC1, [RPL_ADMINLOC1, Nick, 'Russia Krasnoyarsk 8 Marta 24A-7']));
  WriteCl(Socket, Format('%d %s '+MSG_ADMINLOC2, [RPL_ADMINLOC2, Nick, 'Krasnoyarsk State Technical University VT27-4 Ishenin Pavel P.']));
  WriteCl(Socket, Format('%d %s '+MSG_ADMINEMAIL, [RPL_ADMINEMAIL, Nick, 'webpirat@mail.ru']));
end;
procedure TMainForm.MakeUsers(Socket: Integer; Arg: String);
var Nick: String;
    Ulist: TStringList;
    UInfo: TUserInfo;
begin
{ERR_NOSUCHSERVER                ERR_FILEERROR
 ERR_USERSDISABLED}
  UInfo := DataStore.GetUserInfo(Socket);
  Nick := UInfo.Nick;
  WriteCl(Socket, Format('%d %s '+MSG_USERSSTART, [RPL_USERSSTART, Nick]));
  UList := DataStore.GetUsers(UInfo.OPER);
  If Ulist.Count = 0 then WriteCl(Socket, Format('%d %s '+MSG_NOUSERS, [RPL_NOUSERS, Nick]));
  while UList.Count > 0 do
  begin
    WriteCl(Socket, Format('%d %s '+':%s', [RPL_USERS, Nick, UList.Strings[0]]));
    UList.Delete(0);
  end;
  WriteCl(Socket, Format('%d %s '+MSG_ENDOFUSERS, [RPL_ENDOFUSERS, Nick]));
end;

procedure TMainForm.do_refresh_list; //31.03.00
var Item: TListItem;
    i: integer;
    ChInfo: TChannelInfo;
begin
  i := 0;
  while (i <= ChanList.Items.Count - 1) do
  begin
    Item := ChanList.Items.Item[i];
    if (DataStore.FindChannelId(Item.Caption) = 0) then
      Item.Delete else
    begin
      ChInfo := DataStore.GetChannelInfo(Item.Caption);
      Item.SubItems.Strings[0] := ChInfo.FLAGS;
      Item.SubItems.Strings[1] := IntToStr(DataStore.GetUserCount(Item.Caption));
      inc(i);
    end;
  end;
end;
procedure TMainForm.Detailedinfo1Click(Sender: TObject);
begin
 //31.03.00
 if ChanList.Selected <> nil then chan_prop.ShowProp(ChanList.Selected.Caption);
end;
procedure TMainForm.Users1Click(Sender: TObject); //Users on channel
begin
 if ChanList.Selected <> nil then user_pr.ShowProp(ChanList.Selected.Caption);
end;

procedure TMainForm.ChanListDblClick(Sender: TObject);
begin
  Users1Click(Sender);
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  ThreadCache := TThreadList.Create;
  FingerSocket.Addr := '0.0.0.0';
  FingerSocket.Listen;
end;

function  TMainForm.GetThread: TFingerThread;
begin
  with ThreadCache.LockList do
  begin
    if Count > 0 then { cache is not empty }
    begin
      Result := TFingerThread(Items[0]); {Get the availible thread}
      Delete(0); // remove from cache
    end
  else
    Result := TFingerThread.Create;
  end;
end;

procedure TMainForm.FingerSocketSessionAvailable(Sender: TObject;
  Error: Word);
var
  ClientThread  : TFingerThread;
begin
  ClientThread := GetThread;
  ClientThread.SetSocket(FingerSocket.Accept);
  ClientThread.Resume;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
var
  I: Integer;
begin
  { Kill all the threads in the cache }
  with ThreadCache.LockList do
  begin
    for I := Count - 1 downto 0 do
    begin
      TFingerThread(Items[0]).Free; { free the thread }
      Delete(i);     { remove it from the cache }
    end;
  end;
  ThreadCache.Free;
  FingerSocket.Shutdown(2);
  FingerSocket.Close;
end;
procedure TMainForm.MakeHelp(Socket: Integer; Arg: String);
var Nick: String;
    Help_: TStringList;
    Res : boolean;
    I: Integer;
    UInfo: TUserInfo;
begin
  Nick  := DataStore.NickBySocket(Socket);
  Help_ := Help(Arg, Res);
  if Res then
  for I := 0 to Help_.Count -1 do
    WriteCl(Socket, Format('NOTICE %s :%s', [Nick, Help_.Strings[I]]))
  else 
  begin
    UInfo := DataStore.GetUserInfo(Socket);
    WriteCl(Socket, Format('NOTICE %s :%s', [Nick, 'Your help request has been sent']));
    WriteFlag(Format(':%s NOTICE %s :*** HelpOp -- from %s :%s', [ServerName, UInfo.Nick, UInfo.Nick+'!'+UInfo.UserID+'@'+UInfo.HostName, Arg]), 'h');
  end;
  Help_.Free;
end;
procedure TMainForm.GhostTimerTimer(Sender: TObject);
begin
  NSNickCheck(DataStore.IsKillGhost);
end;

end.

