unit nickserv;
interface
  uses Windows, Classes, SysUtils, Dialogs;
  procedure NewNick(Socket: Integer);
  procedure NS(Socket: Integer; Cmd: String);
  procedure NSNickCheck(need: boolean);
  procedure MakeRegister(Socket: Integer; Arg: String);
  procedure MakeSet(Socket: Integer; Arg: String);
  procedure MakeAccess(Socket: Integer; Arg: String);
  procedure MakeIdentify(Socket: Integer; Arg: String);
  procedure MakeRecover(Socket: Integer; Arg: String);
  procedure MakeGhost(Socket: Integer; Arg: String);
  procedure MakeDrop(Socket: Integer; Arg: String);
  procedure MakeRelease(Socket: Integer; Arg: String);
  procedure MakeInfo(Socket: Integer; Arg: String);
  procedure MakeAcc(Socket: Integer; Arg: String);
implementation
uses types, datast, main;
procedure WriteNS(Socket: Integer; What: String);
begin
  MainForm.WriteCl(Socket, 'NOTICE -NickServ- :'+What);
end;
procedure NewNick(Socket: Integer); // Check for the nick
var UInfo: TUserInfo;
    RInfo: TRegUserInfo;
    GInfo: TGhostInfo;
begin
{ 1. Check for nick entry in reguser.dbf
      a) if nick is not present then exit
      b) if nick present then step 2
  2. Check for nick USERID, HOSTNAME
      a) if RegUser.userid = User.UserId and RegUser.HostName = User.HostName then exit
      b) step 3
  3. Check Kill flag
      a) if Kill = false then begin DataStore.AddGhostedNick(Nick); exit; end;
      b) if Kill = true  then Kill(Nick, ''); }
  UInfo := DataStore.GetUserInfo(Socket);
  RInfo := DataStore.GetRegistredUserInfo(UInfo.Nick);
  GInfo.Nick := UInfo.Nick;
  GInfo.Kill := false;
  if RInfo.Id <> 0 then // 1.b
  begin
    if (RInfo.UserId <> UInfo.UserId) or (RInfo.HostName <> UInfo.HostName) then
    // 2.b
      if not Rinfo.Kill then
      begin
        WriteNS(Socket, 'This nickname is owned by someone else. Please choose another.');
        WriteNS(Socket, 'If this is your nickname use "/NickServ IDENTIFY <password>"');
        GInfo.Status := 0;
      end else begin
        WriteNS(Socket, 'This nickname is owned by someone else. Please choose another.');
        WriteNS(Socket, 'If this is your nickname use "/NickServ IDENTIFY <password>"');
        WriteNS(Socket, 'This nickname is owned by someone else. Please choose another.');
        WriteNS(Socket, 'You have 60 seconds before I change your nickname.');
        GInfo.Status := 0;
        GInfo.Kill   := true;
        GInfo.TimeOut:=  3;
        MainForm.GhostTimer.Enabled := true;
      end else  GInfo.Status := 1;
    DataStore.SetGhostInfo(UInfo.Nick, GInfo);
  end;
end;

procedure NS(Socket: Integer; Cmd: String); // Execute Cmd
var Arg: String;
begin
  Arg := '';
  while (Length(Cmd) > 0) and (Cmd[1] = ' ') do Delete(Cmd, 1, 1);
  if Pos(' ', Cmd) > 0 then 
  begin
    Arg := Cmd;
    Delete(Arg, 1, Pos(' ', Arg));
    Delete(Cmd, Length(Cmd) - Length(Arg), Length(Arg) + 1);
  end;
  while (Length(Cmd) > 0) and (Cmd[Length(Cmd)] = ' ') do Delete(Cmd, Length(Cmd), 1);
  If (Cmd = 'register') then
  begin
    MakeRegister(Socket, Arg);
    Exit;
  end;
  if (Cmd = 'set') then
  begin
    MakeSet(Socket, Arg);
    Exit;
  end;
  if (Cmd = 'access') then
  begin
    MakeAccess(Socket, Arg);
    Exit;
  end;
  if (Cmd = 'identify') then
  begin
    MakeIdentify(Socket, Arg);
    Exit;
  end;
  if (Cmd = 'recover') then
  begin
    MakeRecover(Socket, Arg);
    Exit;
  end;
  if (Cmd = 'ghost') then
  begin
    MakeGhost(Socket, Arg);
    Exit;
  end;
  if (Cmd = 'drop') then
  begin
    MakeDrop(Socket, Arg);
    Exit;
  end;
  if (Cmd = 'release') then
  begin
    MakeRelease(Socket, Arg);
    Exit;
  end;
  if (Cmd = 'info') then
  begin
    MakeInfo(Socket, Arg);
    Exit;
  end;
  if (Cmd = 'acc') then
  begin
    MakeAcc(Socket, Arg);
    Exit;
  end;
  WriteNS(Socket, 'Unknown command');
  WriteNS(Socket, 'Type HelpServ NickServ for more info.');
end;
procedure MakeRename(Socket: Integer);
var X: Integer;
    NewNick: String;
begin
   X := Random(100000);
   NewNick := 'ghost' + IntToStr(X);
   MainForm.MakeNick(Socket, NewNick);
end;
procedure NSNickCheck(need: boolean);
var TA: Integer;
    Socket: Integer;
begin
  if not need then MainForm.GhostTimer.Enabled := false else
    with DataStore.Reg_Users do
    begin
     First;
     while not Eof do
     begin
       if DataStore.Reg_UsersKill.AsBoolean then
       begin
         TA := DataStore.Reg_UsersTimeOut.AsInteger;
         Socket := DataStore.SocketByNick(DataStore.Reg_UsersNick.AsString);
         if TA > 1 then 
         begin
            DataStore.Reg_UsersTimeOut.AsInteger := TA - 1 ;
            WriteNS(Socket, Format('You have %d seconds before I change your nickname.', [TA*20]));
         end else MakeRename(Socket);
        end;
        Next;
      end;
    end;
end;
procedure MakeRegister;
var RInfo: TRegUserInfo;
    UInfo:  TUserInfo;
    Nick : String;
    EMail, Passwd: String;
begin
  if Pos(' ', Arg) = 0 then 
  begin
    WriteNS(Socket, 'Register. Not enougth parametres.');
    Exit;
  end else
  begin
    Passwd := Copy(Arg, 1, Pos(' ', Arg) - 1);
    EMail := Arg;
    Delete(EMail, 1, Pos(' ', Arg));
    if Pos('@', EMail) = 0 then
    begin
      WriteNS(Socket, 'Register. Bad Email address.');
      Exit;
    end;
  end;

  UInfo := DataStore.GetUserInfo(Socket);
  Nick := UInfo.Nick;
  RInfo := DataStore.GetRegistredUserInfo(Nick);
  if RInfo.ID = 0 then
  begin
    RInfo.Nick   := Nick;
    RInfo.EMail  := EMail;
    RInfo.Passwd := Passwd;
    RInfo.UserId := UInfo.USerId;
    RInfo.HostName := UInfo.HostName;
    RInfo.Kill := false;
    RInfo.MForward := false;
    RInfo.MLock := false;
    RInfo.MReceipts := false;
    RInfo.NoMemo := false;
    RInfo.NoOp := false;
    RInfo.Secure := false;
    RInfo.ShowEMail := true;
    RInfo.URL := '';
    RInfo.Forward_ := '';
    DataStore.SetRegistredUserInfo(Nick, RInfo);
    WriteNS(Socket, 'Register. You are now registred user. Your password is '+passwd);
  end else WriteNs(Socket, 'Register. User '+Nick+' is already registred.');
end;
procedure MakeSet;
begin
  WriteNs(Socket, 'Unimplemented yet :((');
end;
procedure MakeAccess;
begin
  WriteNs(Socket, 'Unimplemented yet :((');
end;
procedure MakeIdentify;
begin
  WriteNs(Socket, 'Unimplemented yet :((');
end;
procedure MakeRecover;
begin
  WriteNs(Socket, 'Unimplemented yet :((');
end;
procedure MakeGhost;
begin
  WriteNs(Socket, 'Unimplemented yet :((');
end;
procedure MakeDrop;
begin
  WriteNs(Socket, 'Unimplemented yet :((');
end;
procedure MakeRelease;
begin
  WriteNs(Socket, 'Unimplemented yet :((');
end;
procedure MakeInfo;
begin
  WriteNs(Socket, 'Unimplemented yet :((');
end;
procedure MakeAcc;
begin
  WriteNs(Socket, 'Unimplemented yet :((');
end;

initialization
  randomize;
end.