unit types;
interface
uses windows, irc_const, SysUtils, Classes;
type
    TUserInfo = record
      ID: Cardinal;
      NICK: String[NICKLEN];
      USERID: String[NICKLEN];
      HOSTNAME: String[HOSTLEN];
      REALNAME: String[REALLEN];
      INVISIBLE: Boolean;
      OPER: Boolean;
      WALLOP: Boolean;
      LOGIN: byte;
      SERVICE: Boolean;
      SOCKET: Cardinal;
      EXTMODE: String[10];
      Time: DWORD;
      Away: String[255];
    end;
    TRegUserInfo = record
      ID        : Cardinal;
      Nick      : String[NickLen];
      UserID    : String[NickLen];
      HostName  : String[HostLen];
      KILL      : Boolean;
      MForward  : Boolean;
      MLock     : Boolean;
      MReceipts : Boolean;
      NoMemo    : Boolean;
      NoOp      : Boolean;
      Secure    : Boolean;
      ShowEmail : Boolean;
      URL       : String[255];
      PASSWD    : String[PasswdLen];
      EMail     : String[255];
      Forward_   : String[NickLen];
    end;
    TGhostInfo = record
      ID        : Cardinal;
      Nick      : String[NickLen];
      Status    : Cardinal;
      TimeOut   : Cardinal;
      Kill      : Boolean;
    end;
    TChannelInfo = record
      ID: Cardinal;
      NAME: String[ChannelLen];
      FLAGS: String[10];
      TOPIC: String[TopicLen];
      CTIME: DWORD; // Channel creation time
      TTIME: DWORD; // Channel topic change(set) time
      KEY: String[KeyLen];
      LIMIT: Cardinal;
    end;
    TOperInfo = record
      NAME: String[NickLen];
      PASS: String[PASSWDLEN];
      HOSTMASK: String[HOSTLEN];
      FLAGS: String[10];
    end;
function CharInString(C: Char; S: String): Cardinal;
function atoi(S: String): Integer;
function itoa(i: Integer): String;
function Chop(S: String): String;
function EqualHosts(H1, H2: String): boolean;
function EqualNames(N1, N2: String): boolean;
function NickCheck(var S: String; l: integer): Boolean;
function SortChars(var S: String): String;
function GetArg(var Args: String): String;

var
  ThreadCache: TThreadList;
  ThreadCacheSize : integer;

implementation
function CharInString(C: Char; S: String): Cardinal;
var I: Cardinal;
begin
 Result := 0;
 For I := 1 to Length(S) do
  If S[I] = C then Inc(Result);
end;
function atoi;
var code: integer;
begin
 val(s, Result, code);
end;
function Chop;
begin
  Result := S;
  while (Length(Result) > 0) and (Result[1] < #33) do
    Delete(Result, 1, 1);
  while (Length(Result) > 0) and (Result[Length(Result)] < #33) do
    Delete(Result, Length(Result), 1);
end;
function EQualHosts;
var p1, p2: String;
begin
  if (H1 ='*') or (H2 = '*') or (H1 = H2) then
  begin
    Result := true;
    Exit;
  end;
  if (CharInString('.', H1) <> CharInString('.', H2)) and
     ((CharInString('*', H1) = 0) and (CharInString('*', H2) = 0))
  then begin
    Result := false;
    Exit;
  end;
  If (CharInString('.', h1) = 0) or (CharInString('.', h2) = 0)
  then begin
    Result := false;
    Exit;
  end;
  Result := true;
  if (pos('.*', h1) = Length(h1) - 1) or (pos('.*', h2) = Length(h2) - 1) then
  begin
    Delete(h1, pos('.*', h1), Length(h1));
    Delete(h2, pos('.*', h2), Length(h2));
    if (pos(h1, h2) > 0) or (pos(h2, h1) > 0) then Result := true
    else Result := false;
  end else
    while (CharInString('.', h1) > 0) and (CharinString('.', h2) > 0) and Result do
    begin
      p1 := Copy(h1, 1, pos('.', h1)-1);
      p2 := Copy(h2, 1, pos('.', h2)-1);
      delete(h1, 1, length(p1)+1);
      delete(h2, 1, length(p2)+1);
      if (h1 = h2) or (CharInString('*', h1) > 0) or
         (CharInString('*', h2) > 0) then Result := true
         else Result := false;
    end;
end;
function IsValid(C: Char): boolean;
begin
  if ((c >= 'A') and (c <= '~')) or (c in ['0'..'9']) or (c = '-') then
  begin
    Result := true;
    Exit;
  end;
  if (c >= #$C0) then
  begin
     Result := true;
     exit;
  end;
  if (c = #$A3) or (c = #$B3) then
  begin
    Result := true;
    Exit;
  end;
  Result := false;
end;
function NickCheck;
var I: Integer;
begin
  Result := true;
  if (S[1] in ['0'..'9']) or (S[1] = '-') then
  begin
    Result := false;
    Exit;
  end;
  For I := 1 to Length(S) do
   if (not IsValid(S[I])) or (S[I] = ' ') then
   begin
     Result := false;
     Exit;
   end;
  If Length(S) > l then S := Copy(S, 1, l); 
end;
function itoa;
begin
  Str(i, result);
end;
function SortChars;
var f: boolean;
    i: integer;
    c: char;
begin
  f := true;
  while f do
  begin
    f:= false;
    for i := 1 to Length(S) - 1 do
      if S[i] > S[i+1] then
      begin
         f := true;
         c := S[i];
         S[i] := S[i+1];
         S[i+1] := c;
      end;
   end;
 Result := S;
end;
function EqualNames;
begin
  N1 := LowerCase(N1);
  N2 := LowerCase(N2);
  If (N1 = N2) or (N1 = '*') or (N2 = '*') or (Length(N1) = 0) or (Length(N2) = 0)then
  begin
    Result := true;
    Exit;
  end;
  If (CharinString('*', N1) = 0) and (charInString('*', N2) = 0) then
  begin
    Result := false;
    Exit;
  end;
  If ((N1[1] = '*') and (N2[Length(N2)] = '*')) or ((N2[1] = '*') and (N1[Length(N1)] = '*')) then
  begin
    Result := true;
    Exit;
  end;
  If N1[1] = '*' then
  begin
    Delete(N1, 1, 1);
    Delete(N2, 1, Length(N2) - Length(N1));
  end;
  If N2[1] = '*' then
  begin
    Delete(N2, 1, 1);
    Delete(N1, 1, Length(N1) - Length(N2));
  end;
  If N1[Length(N1)] = '*' then
  begin
    Delete(N1, Length(N1), 1);
    Delete(N2, Length(N1)+1, Length(N2));
  end;
  If N2[Length(N2)] = '*' then
  begin
    Delete(N2, Length(N2), 1);
    Delete(N1, Length(N2)+1, Length(N1));
  end;
  Result := false;
  If (N1 = N2) then Result := true;
end;
function GetArg(var Args: String): String;
begin
  If CharInString(' ', Args) > 0 then
  begin
    Result := Copy(Args, 1, Pos(' ', Args)-1);
    Delete(Args, 1, Length(Result)+1);
  end else begin Result := Args; Args := ''; end;
end;
end.
